var mApplication = angular.module('SdpNews', [
  'ionic',
  //'news.service',
  'news.widgets',
  'news.controller.main',
  //'news.controller.news_list',
  'news.controller.news_detail',
  'news.controller.comment',
  //'news.controller.praisers',
  'news.controller.photoview',
  'news.controller.topic',
  'i18n_module'
]);

//-------------------------------- 路由 -----------------------------------//
mApplication.config(["$stateProvider", "$urlRouterProvider", "$ionicConfigProvider",
  function($stateProvider, $urlRouterProvider, $ionicConfigProvider) {
    $stateProvider
      .state('main', { // 首页面
        url: "/main",
        templateUrl: "templates/main.html",
        controller: 'MainPageCtrl'
      })
      .state('newsList', { // 新闻列表
        url: "/newsList",
        templateUrl: "templates/newsList.html",
        controller: 'NewsListCtrl'
      })
      .state('newsDetail', { // 图文新闻详情页面
        url: "/newsDetail",
        templateUrl: "templates/newsDetail.html",
        controller: 'NewsDetailPageCtrl'
      })
      .state('topicDetail', { // 专题详情页面
        url: "/topicDetail",
        templateUrl: "templates/topicDetail.html",
        controller: 'TopicPageCtrl'
      })
      .state('newsPraisers', { // 新闻点赞详情页面
        url: "/newsPraisers",
        templateUrl: "templates/newsPraisers.html",
        controller: 'NewsPraisersCtrl'
      })
      .state('comments', { // 评论详情页面
        url: "/comments",
        templateUrl: "templates/comments.html",
        controller: 'CommentsPageCtrl'
      })
      .state('photoView', { // 图片浏览页面
        url: "/photoView",
        templateUrl: "templates/photoView.html",
        controller: 'PhotoPageCtrl'
      });

    // 设置默认页面
    $urlRouterProvider.otherwise("/main");

    // 关闭转场特效
    $ionicConfigProvider.views.transition(mMobileDevice ? 'none' : 'ios');
    $ionicConfigProvider.views.maxCache(5);
  }
]);
