// 新闻列表 控制器
angular.module('news.controller.index', ['news.service.cordova', 'i18n_module'])
  .controller('indexCtrl', ['$rootScope', '$scope', '$timeout', '$location', '$sce', '$element', 'cordovaService', '$translate', '$filter',
    function($rootScope, $scope, $timeout, $location, $sce, $element, $cordovaService, $translate, $filter) {
      $scope.mScrollerHeight = document.documentElement.clientHeight;
      $scope.mNetworkErr = false;

      registerEventBus("indexCtrl_element_refresh", function(event) {
        if (EVENT_ELEMENT_REFRESH === event) {
          $scope.$digest();
        }
      });

      function initData() {

        getCategories(function(categories, statusCode) {
          $scope.offline = false;
          if (SUCCESS === statusCode && categories !== undefined) {
            $scope.inited = true;
            if (mCordovaSupport) {
              if (mCordovaReady) {
                $cordovaService.pushCategoriesData([categories]);
              } else {
                registerEventBus("indexCtrl_pushCategoriesData", function(event) {
                  if (EVENT_CORDOVA_READY === event) {
                    $cordovaService.pushCategoriesData([categories]);
                  }
                });
              }
            }
          } else{
            // 获取板块数据异常
            $scope.offline = true;
            $scope.mNetworkErr = statusCode === 600;
            $scope.noCategory = statusCode === EMPTY;
            $scope.$digest();
          }

        });
      }

      /**
       * 初始化
       */
      $scope.init = function() {
        //IOS反劫持白名单
        if (mPlatformIOS) {
          MUICordovaWebJSExport.addDNSOptimizeURL('news.web.sdp.101.com');
          MUICordovaWebJSExport.addDNSOptimizeURL('interaction.web.sdp.101.com');
          MUICordovaWebJSExport.addDNSOptimizeURL('aqapi.101.com');
        }
        $scope.mNetworkErr = false;

        initData();
      };

      window.translate = function(msg) {
        return $filter('translate')(msg);
      };

    }
  ]);
