// 新闻点赞详情页 控制器
angular.module('news.controller.praisers', ['news.service.common', 'news.service.interaction', 'news.service.cordova', 'i18n_module'])
    .controller('NewsPraisersCtrl',
    ['$scope', '$timeout', '$location', 'common', 'interactionService', '$translate', 'cordovaService', '$filter',
        function ($scope, $timeout, $location, $common, $interactionService, $translate, $cordovaService, $filter) {
            log("NewsPraisersCtrl");

            /****************************************************************************/

            var PRAISERS_REQUEST_SIZE = 99;


            $scope.newsPraisers = new Array();
            $scope.min_irt_id;
            $scope.max_irt_id;

            $scope.requestTime;

            /****************************************************************************/

            registerEventBus("NewsPraisersCtrl_element_refresh", function (event) {
                if (EVENT_ELEMENT_REFRESH === event) {
                    $scope.$digest();
                }
            })

            $scope.getNewsPraiserName = function (praiser) {
                return getPraiserName(praiser);
            };

            $scope.getNewsPraisersLatest = function () {
                timeLog(22, "Start");
                $interactionService.getNewsPraisersLatest($scope.newsPraisers, $scope.newsID, PRAISERS_REQUEST_SIZE, function (statusCode) {
                    $scope.requestTime = getNowUnixTime();

                    if (SUCCESS === statusCode) {

                        var uids = new Array();

                        for (var i = 0; i < $scope.newsPraisers.length; i++) {
                            var praiser = $scope.newsPraisers[i];
                            if (praiser != undefined) {
                                uids.push(praiser.uid);

                                _updateIrtIds(praiser.irt_id);
                            }
                        }

                        _updateCommentUserNameBatch(uids);

                    }
                    $scope.$digest();
                    timeLog(22, "End");

                    $cordovaService.donePulldown();
                });
            };

            $scope.getNewsPraisersOlder = function () {
                timeLog(22, "Start");
                $interactionService.getNewsPraisersOlder($scope.newsPraisers, $scope.newsID, $scope.max_irt_id, PRAISERS_REQUEST_SIZE, function (statusCode) {
                    if (SUCCESS === statusCode) {

                        var uids = new Array();

                        for (var i = 0; i < $scope.newsPraisers.length; i++) {
                            var praiser = $scope.newsPraisers[i];
                            if (praiser != undefined) {
                                uids.push(praiser.uid);

                                _updateIrtIds(praiser.irt_id);
                            }
                        }

                        _updateCommentUserNameBatch(uids);

                    } else if (EMPTY === statusCode) {
                        $common.toast($translate.instant('parisers_no_more_info'));
                    }

                    $scope.$digest();
                    timeLog(22, "End");

                    $cordovaService.donePullup();
                });
            };

           /**
           * 获取 用户头像
           */
           $scope.getUserAvatar=function(userID){
            if(userID==undefined){
              return  './images/default_avatar.png';
            }
            if (mPlatformAndroid) {
             return  jscallusericon.getUserIconUrl(userID,DEFAULT_AVATAR_SIZE);
            } else if (mPlatformIOS) {
            return MUICordovaWebJSExport.getUserAvatarURLString(userID,DEFAULT_AVATAR_SIZE);
            }

          };

            $scope.init = function () {
                $scope.newsID = $.getUrlParam('newsid');
                $scope.getNewsPraisersLatest();

                if ( mCordovaSupport ) {
                    if ( mCordovaReady ) {
                        $cordovaService.addPullRefreshForIos();
                    } else {
                        registerEventBus( "NewsPraisersCtrl_add_pull_refresh", function(event) {
                            if ( EVENT_CORDOVA_READY === event ) {
                                $cordovaService.addPullRefreshForIos();
                            }
                        })
                    }
                }
            }

            /****************************************************************************/

            var _updateCommentUserNameBatch = function (uids) {
                updateCommentUserNameBatch(uids, function () {
                    $scope.$digest();
                });
            }

            var _updateIrtIds = function (irtID) {
                if ($scope.min_irt_id === undefined || irtID < $scope.min_irt_id) {
                    $scope.min_irt_id = irtID;
                }

                if ($scope.max_irt_id === undefined || irtID > $scope.max_irt_id) {
                    $scope.max_irt_id = irtID;
                }
            }

            var _getRequestTime = function() {
                if ( $scope.requestTime ) {
                    return new Date($scope.requestTime).format(DEFAULT_TIME_FORMAT);
                }
                return $filter('translate')('no_more_items');
            }

            /****************************************************************************/

            window.translate = function(msg) {
                return $filter('translate')(msg);
            }

            window.startPullDownToRefresh = function () {
                var time = $filter('translate')('refresh_time') + _getRequestTime();
                if (mPlatformAndroid) {
                    webView.setRefreshTime( time );
                } else if (mPlatformIOS) {
                    $cordovaService.setRefreshTimeForIos(time);
                }
            }

            window.onPullDownToRefresh = function () {
                $scope.getNewsPraisersLatest();
            }

            window.onPullUpToRefresh = function () {
                $scope.getNewsPraisersOlder();
            }
        }]);
