// 图集新闻详情页 控制器
angular.module('news.controller.photoview', ['ionic'])
  .controller('PhotoPageCtrl', ['$rootScope', '$scope', '$ionicLoading', '$timeout', '$ionicSlideBoxDelegate', '$ionicScrollDelegate', '$location', '$translate', '$filter',
    function($rootScope, $scope, $ionicLoading, $timeout, $ionicSlideBoxDelegate, $ionicScrollDelegate, $location, $translate, $filter) {
      log("PhotoPageCtrl");

      $scope.mGalleryImgWidth = document.documentElement.clientWidth;
      $scope.mGalleryImgHeight = document.documentElement.clientHeight;

      $scope.inited = false;

      $scope.slideChanged = function(index) {
        $scope.slideIndex = index;
        log("slideChanged :: " + index);
      };

      $scope.initSlidePosition = 0;

      /**
       * 获取SlideBox初始化索引
       * @returns {number}
       */
      $scope.getInitSlidePosition = function() {
        return $scope.initSlidePosition;
      };

      $scope.init = function() {
        var newsID = $.getUrlParam('newsid');

        if (mCurrentDetailNews !== undefined) {
          $timeout(function() {
            $scope.inited = true;
            $scope.mCurrNews = mCurrentDetailNews;
            $scope.publishTime = new Date($scope.mCurrNews.publish_time).format(DEFAULT_TIME_FORMAT);


            var imgUrl = $location.search().imgurl;
            if (imgUrl !== undefined) {
              var images = mCurrentDetailNews.images;
              for (var i = 0; i < images.length; i++) {
                if (images[i] !== undefined) {
                  var url = images[i].url;
                  if (imgUrl === url) {
                    log("value-->" + url);
                    $scope.initSlidePosition = i;
                    break;
                  }
                }
              }
            }
          }, DEFAULT_INIT_DELAY);
        }

      };

      $scope.descToHtml = function(index, desc) {
        var str = "<span class='gallery-index'>" + index + "</span><span class='gallery-count'>/" + $scope.mCurrNews.images.length + "</span> ";
        if (desc) {
          str += desc;
        }
        return str;
      };

      $scope.goBigPicView = function(url) {
        goBigPicView(url);
      };

      /****************************************************************************/
      window.translate = function(msg) {
        return $filter('translate')(msg);
      };
    }
  ]);
