/**
 * 新闻分类
 * @param id
 * @constructor
 */
function Category(id) {
  this.id = id; // 分类ID
  this.desc = ""; // 描述
  this.name = ""; // 名称
  this.sort = 0; // 排序

  this.lastUpdateNewsTime = 0;
  this.newsRequested = false; // 是否 获取过新闻信息
  this.moreOlderNews = true;

  this.maxTs = INVALID; // 最大时间（最新）
  this.minTs = INVALID; // 最小时间（最旧）

  this.hasNews = false; // 是否有分类的新闻
  this.appendSize = 0;

  this.newsArray = [];
  this.thumbNews = [];
}


/**
 * 新闻实体
 * @param id
 * @constructor
 */
function News(id) {
  this.id = id; // 新闻ID

  this.categories; // 新闻所属分类
  this.images; // 新闻图集
  this.publish_time; // 新闻发布时间
  this.summary; // 新闻摘要
  this.tags;
  this.title; // 新闻标题
  this.topic_flag = -1; // 新闻专题 类型
  this.topics; // 新闻专题
  this.type; // 新闻类型

  this.content; // 新闻正文
  this.create_time; // 新闻创建时间
  this.creator_id; // // 新闻创建者UID
  this.creator_name; // 新闻创建者名称
  this.source; // 新闻来源
  this.update_time; // 新闻更新时间

  this.isRead = false; // 是否已经点阅
  this.isPraise = false; // 是否已经点赞
  this.praiseNum = 0; // 点赞数量
  this.commentsNum = 0; // 评论数量
  this.hits = 0;
  this.layout = 0;
}


/**
 * 新闻评论
 * @constructor
 */
function Comment(id) {
  this.id = id; // 评论ID
  this.cmt_id = 0;
  this.news_id;
  this.content; // 评论内容
  this.ower_uid; // 评论者ID
  this.time; // 评论时间 ( eg : "2015-04-16T10:06:32.189+0000" )
}

/**
 * 评论CmtID标识
 * @constructor
 */
function CommentConfig() {
  this.min_cmt_id = INVALID; // 最小时间（最旧）
  this.max_cmt_id = INVALID; // 最大时间（最新）
  this.requestTime;
  this.hasOlderComment = true;
}


/**
 * 点赞用户信息
 * @param uid
 * @constructor
 */
function Praiser(uid) {
  this.uid = uid;
  this.irt_id;
  this.irt_type;
  this.op_time;
}


/**
 * 专题对象
 * @param id
 * @constructor
 */
function Topic(id) {
  this.id = id; // 专题ID
  this.create_time; // 专题创建时间
  this.name; // 专题名称
  this.summary; // 专题摘要
  this.update_time; // 专题更新时间
  this.cover_img; // 专题标题图片

  this.lastUpdateNewsTime = 0;
  this.newsRequested = false; // 是否 获取过新闻信息
  this.minTs = INVALID; // 最小时间（最旧）
  this.maxTs = INVALID; // 最大时间（最新）
  this.moreOlderNews = true;

  this.appendSize = 0;
  this.newsArray = [];
}


/**
 * 用户信息
 * @param id
 * @constructor
 */
function UserInfo(id) {
  this.id = id;
  // this.name; // 用户账户名称
  // this.user_name; // 用户账户名称
  // this.nick_name; // 用户昵称
  // this.real_name;
  // this.nick_name_full; // 用户名 英文全名
  // this.nick_name_short; // 用户名 英文缩写
  // this.node_id;
  // this.node_name;
  this.last_update_time = 0;
}
