var ___getJSONCache = {};
var PROJECT = 'news';
var pnlToastMsg, showing;

var timeoutAlerting;
/**
 * 模仿Toast效果，主要是用于在不打断程序正常执行的情况下显示提示数据
 * @param config
 * @return
 */
var mToastShowing = false;

var Toast = function(message, callback) {
  if (window.NativeToast) {
    if (mCordovaReady) {
      window.NativeToast(message);
    } else {
      document.addEventListener('deviceready', function() {
        window.NativeToast(message);
      }, false);
    }
    return;
  }

  var context = $('body'); //上下文
  var top = '150px'; //距容器上方的距离

  var toast = $("#global-toast");
  if (toast.length <= 0) {
    toast = $("<div id='global-toast'/>").appendTo(context);
    toast.css({
      position: 'fixed',
      'z-index': '99999',
      'background-color': 'black',
      display: "none",
      color: 'white',
      'font-size': '15px',
      padding: '16px 10px',
      margin: '10px',
      opacity: 0.8,
      borderRadius: "4px"
    });
  }

  toast.text(message);
  var top = top == null ? '150px' : top;
  var left = ($(window).width() - toast.width()) / 2 - 20;
  toast.css({
    top: top,
    left: left
  });

  var totalTime = 2000; //持续时间
  var fadeInTime = totalTime * 0.5;
  var fadeOutTime = totalTime - fadeInTime;

  if (mToastShowing) {
    toast.stop();
    toast.hide();
    toast.fadeIn(fadeInTime);
  } else {
    toast.fadeIn(fadeInTime);
    mToastShowing = true;
  }
  toast.delay(fadeInTime).fadeOut(fadeOutTime, function() {
    mToastShowing = false;

    if (callback != undefined) {
      callback();
    }
  });
}

$.extend($, {
  randomCode: function() {
    code = "";
    var codeLength = 8; //验证码的长度
    var chars = new Array(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z'); //所有候选组成验证码的字符，当然也可以用中文的

    for (var i = 0; i < codeLength; i++) {
      var charIndex = Math.floor(Math.random() * 36);
      code += chars[charIndex];
    }
    return code;
  },
  getAuthHeader: function(url, method) {
    var access_token = $.getUrlParam("access_token");
    if (access_token) {
      $.setCookie('access_token', access_token);
    } else {
      access_token = $.getCookie('access_token');
    }
    var mac_key = $.getUrlParam("mac_key");
    if (mac_key) {
      $.setCookie('mac_key', mac_key);
    } else {
      mac_key = $.getCookie('mac_key');
    }

    if (!access_token || !mac_key) {
      return;
    }
    if (!window.CryptoJS) {
      alert('please include crypto lib in the page.');
    }

    var strAuth = 'MAC id="' + access_token + '",nonce="';
    var timestamp = window.localStorage.getItem('timestamp_minus');
    timestamp = timestamp ? +timestamp : 0;
    var nonce = (new Date().getTime() + timestamp) + ':' + $.randomCode();
    strAuth += nonce + '",mac="';
    var host;
    if (location.hostname.indexOf(PROJECT + '.') !== 0) {
      host = mCurrentApiHost;
    } else {
      host = location.hostname;
    }
    var path;
    var pos = url.indexOf("://");
    if (pos > 0) {
      path = url.substring(pos + 3);
      pos = path.indexOf("/");
      host = path.substr(0, pos);
      path = path.substring(pos);
    } else {
      path = url;
    }
    var request_content = nonce + '\n' + method + '\n' + path + '\n' + host + '\n';
    var hash = CryptoJS.HmacSHA256(request_content, mac_key);
    var mac = hash.toString(CryptoJS.enc.Base64);
    strAuth += mac + '"';
    return strAuth;
  },
  ajaxJSON: function(method, url, data, success, failure, settings) {
    var dfd = $.Deferred();

    if (jQuery.isFunction(data)) {
      settings = failure;
      failure = success;
      success = data;
      data = {};
    }

    if (method != 'GET') {
      data = JSON.stringify(data);
    }

    if (url.indexOf("://") < 1) {
      url = mCurrentApiHost + url;
    }

    var params = [{
      'url': url
    }, data || {}, {
      'method': method
    }];
    var str = new Date().getTime().toString(16) + Math.random().toString(16).substring(2);
    var scb = 's' + str;
    var fcb = 'f' + str;

    window[scb] = function(data){
      return success(data);
    };
    window[fcb] = function(data) {
      var statusCode = data.code;
      var responseText = data.msg;
      if (typeof statusCode === "string" && statusCode !== 'timeout') {
        if (/^\w+\/OUT_OF_SERVICE$/.test(statusCode)) {
          Toast(responseText);
        }else if (statusCode !== "WAF/GUEST_ACCESS_DENIED" && (statusCode !== "UC/AUTH_INVALID_TOKEN") && ( statusCode!=='UC/AUTH_INVALID_TIMESTAMP')) {
          Toast(window.translate(statusCode));
        }
      } else {
        if (!statusCode || statusCode === 408 || statusCode === 504 || statusCode === 'timeout' || !responseText) {
          Toast(window.translate("network_slow"));
        }

        if (statusCode === 401 || statusCode === 403) {
          if (responseText.indexOf("时间戳") > 0) {
            //Toast("手机时间有误(导致数据请求出错)，请校正后重新登录。",
            Toast(window.translate("your_phone_display_wrong_time"), function() {
              $.gotoLogin();
            });
          } else {
            $.gotoLogin();
          }
        }

        if (statusCode === 1200) {
          Toast(window.translate("parameter_error"));
        }
      }

      return failure(data);
    };

    if (mPlatformAndroid) {
      JsHttpRequest.execute(JSON.stringify(params), scb, fcb);
    } else if (mPlatformIOS) {
      MUICordovaWebJSExport.execute(JSON.stringify(params), scb, fcb);
    }

    return dfd.promise();
  },
  postJSON: function(url, data, success, failure, settings) {
    return $.ajaxJSON('POST', url, data, success, failure, settings);
  },
  getJSON: function(url, data, success, failure, settings) {
    return $.ajaxJSON('GET', url, data, success, failure, settings);
  },
  putJSON: function(url, data, success, failure, settings) {
    return $.ajaxJSON('PUT', url, data, success, failure, settings);
  },
  deleteJSON: function(url, data, success, failure, settings) {
    return $.ajaxJSON('DELETE', url, data, success, failure, settings);
  },
  model: function(options, success, failure) {
    var url = options.url;
    var type = options.type;
  },
  initEvent: function(e) {
    //firefox 下 绑定 srcElement=target
    //简写srcElement
    if (e.target)
      e.srcElement = e.target;
    if (e.which)
      e.keyCode = e.which;
    e.src = e.srcElement;
  },
  stringFormat: function(str) {
    for (var i = 0; i < arguments.length - 1; i++) {
      str = str.replace("{" + i + "}", arguments[i + 1]);
    }
    return str;
  },
  getDateString: function(str) {
    if (str) {
      var date = new Date(parseInt(str.substr(6)));
      var str = date.getFullYear() + "-" + (date.getMonth() + 1) + "-" + date.getDate();
    } else {
      var date = new Date();
      var str = date.getFullYear() + "-" + (date.getMonth() + 1) + "-" + date.getDate();
    }
    return str;
  },
  getDateObj: function(str) {
    return new Date(parseInt(str.substr(6)));
  },
  getFormValues: function($form) {
    values = {};
    $folunchOrder.find(":input").each(function(index, elm) {
      if (elm.name && elm.name.indexOf('__') < 0) {
        values[elm.name] = $(elm).val();
      }
    });
    return values;
  },
  getUrl: function() {
    return location.href.split('?')[0];
  },
  getUrlParams: function() {
    var vars = [],
      hash;
    var pos0 = window.location.href.indexOf('?') + 1;
    var ps = window.location.href.substring(pos0);
    var pos1 = ps.indexOf('#');
    if (pos1 > 0) {
      ps = ps.substring(0, pos1);
    }

    var hashes = ps.split('&');
    for (var i = 0; i < hashes.length; i++) {
      hash = hashes[i].split('=');
      vars.push(hash[0]);
      vars[hash[0]] = hash[1];
    }
    return vars;
  },
  getUrlParam: function(name) {
    return $.getUrlParams()[name];
  },
  getUrlAnchors: function() {
    var vars = [],
      hash;
    var hashes = window.location.href.slice(
      window.location.href.indexOf('#') + 1).split('&');
    for (var i = 0; i < hashes.length; i++) {
      hash = hashes[i].split('=');
      vars.push(hash[0]);
      vars[hash[0]] = hash[1];
    }
    return vars;
  },
  getUrlAnchor: function(name) {
    return $.getUrlAnchors()[name];
  },
  removeFromArray: function(array, removeItem) {
    return jQuery.grep(array, function(value) {
      return value != removeItem;
    })
  },
  uniqueArray: function(array) {
    var ret = [],
      done = {};
    try {
      for (var i = 0, length = array.length; i < length; i++) {
        var tmp = array[i]; // jQuery native code : var id =
        // jQuery.data(array[i]);
        if (!done[tmp]) {
          done[tmp] = true;
          ret.push(tmp);
        }
      }
    } catch (e) {
      ret = array;
    }
    return ret;
  },
  // 写入cookies
  setCookie: function(name, value, expiresDays) {
    var Days = expiresDays || 30;
    var d = new Date();
    var exp = new Date(d.getFullYear(), d.getMonth(), d.getDate());
    exp.setTime(exp.getTime() + Days * 24 * 60 * 60 * 1000);
    document.cookie = name + "=" + escape(value) + ";path=/;expires=" + exp.toGMTString();
  },
  // 读取cookies
  getCookie: function(name) {
    var arr, reg = new RegExp("(^| )" + name + "=([^;]*)(;|$)");
    if (arr = document.cookie.match(reg))
      return unescape(arr[2]);
    else
      return null;
  },
  // 删除cookies
  delCookie: function(name) {
    var exp = new Date();
    exp.setTime(exp.getTime() - 1);
    var cval = this.getCookie(name);
    if (cval != null)
      document.cookie = name + "=" + cval + ";expires=" + exp.toGMTString();
  },
  getUUID: function() {
    //    var str = new Date();
    //    str = str.getTime();
    //    return str;
    var d = new Date().getTime();
    var uuid = 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function(c) {
      var r = (d + Math.random() * 16) % 16 | 0;
      d = Math.floor(d / 16);
      return (c == 'x' ? r : (r & 0x7 | 0x8)).toString(16);
    });
    return uuid;
  },
  urlEncode: function(str) {
    var ret = "";
    var strSpecial = "!\"#$%&'()*+,/:;<=>?[]^`{|}~%";
    for (var i = 0; i < str.length; i++) {
      var chr = str.charAt(i);
      var c = ("0" + chr.charCodeAt(0).toString(16)).slice(-2);
      if (parseInt("0x" + c) > 0x7f) {
        ret += "%" + c.slice(0, 2) + "%" + c.slice(-2);
      } else {
        if (chr == " ")
          ret += "+";
        else if (strSpecial.indexOf(chr) != -1)
          ret += "%" + c.toString(16);
        else
          ret += chr;
      }
    }
    return ret;
  },
  urlDecode: function(zipStr) {
    var uzipStr = "";

    function _asciiToString(asccode) {
      return String.fromCharCode(asccode);
    }
    for (var i = 0; i < zipStr.length; i++) {
      var chr = zipStr.charAt(i);
      if (chr == "+") {
        uzipStr += " ";
      } else if (chr == "%") {
        var asc = zipStr.substring(i + 1, i + 3);
        if (parseInt("0x" + asc) > 0x7f) {
          uzipStr += decodeURI("%" + asc.toString() + zipStr.substring(i + 3, i + 9).toString());
          i += 8;
        } else {
          uzipStr += _asciiToString(parseInt("0x" + asc));
          i += 2;
        }
      } else {
        uzipStr += chr;
      }
    }

    return uzipStr;
  },
  returnBack: function(defaultUrl) {
    //    console.info(document.referrer);
    //    console.info($.urlDecode($.getUrlParam('returnUrl') || defaultUrl || document.referrer || '/'));
    location.href = $.urlDecode($.getUrlParam('returnUrl') || defaultUrl || document.referrer || '/');
  },
  gotoLogin: function() {
    if (!mOfflineMode) {
      window.top.location.href = '../user/login.html?returnUrl=' + $.urlEncode(window.top.location.href || document.referrer || '/');
    }
  },
  debug: function(message) {
    var dev = (location.hostname == "127.0.0.1" || location.hostname == "0.0.0.0" || location.hostname == "localhost" || location.port.length > 0)
    dev && typeof console != "undefined" && console.log(message);
  }

});

if (!Object.keys) {
  Object.keys = function(obj) {
    return $.map(obj, function(v, k) {
      return k;
    });
  };
}

/*
 * 日期格式化
 */
Date.prototype.format = function(format) {
  var o = {
    "M+": this.getMonth() + 1, //month
    "d+": this.getDate(), //day
    "h+": this.getHours(), //hour
    "m+": this.getMinutes(), //minute
    "s+": this.getSeconds(), //second
    "q+": Math.floor((this.getMonth() + 3) / 3), //quarter
    "S": this.getMilliseconds() //millisecond
  }

  if (/(y+)/.test(format)) {
    format = format.replace(RegExp.$1, (this.getFullYear() + "").substr(4 -
      RegExp.$1.length));
  }

  for (var k in o) {
    if (new RegExp("(" + k + ")").test(format)) {
      format = format.replace(RegExp.$1, RegExp.$1.length == 1 ? o[k] : ("00" + o[k]).substr(("" + o[k]).length));
    }
  }
  return format;
};

(function($) {
  $.fn.findParent = function(expr) {
      var parents = this.parentsUntil(expr);
      return $(parents[parents.length - 1]).parent();
    }
    //var originalValFunc = $.fn.val;
    //$.fn.val = function(value){
    //if(!arguments.length){
    //  return originalValFunc.call(this);
    //}else{
    //  originalValFunc.call(this, value);
    //  this.trigger('valueBound');
    //}
    //};
})(jQuery);
