cordova.define("com.nd.android.sdp.cordova.library.CommonServiceApi",
    function (require, exports, module) {

        var exec = require('cordova/exec');

        /**
         * 页面跳转
         * @param params  参数
         * @param url   页面跳转链接
         */
        exports.pageJump = function (flag, params, url) {
            var params = {
                url: url,
                params: params
            }
            exec(null, null, "CommonServiceApi", flag, [params]);
        };

        /**
         * 导航菜单
         * @param params 导航菜单内容
         * 注意：该参数应该是这样格式的
         *      [
         *         {
 *            “menu”：“name”， //菜单名称
 *            “page”：“”       //页面标识
 *            “url”：“..”      //菜单跳转链接
 *         }
         *        …
         *       ]
         */
        exports.pageMenu = function (params) {
            exec(null, null, "CommonServiceApi", "action_menu", params);
        };

        /**
         * 版块
         * @param params 版块内容
         * 注意：该参数应该是这样格式的
         *      [
         *         {
 *            “category”：“name”， //版块名称
 *            “url”：“..”      //版块url
 *         }
         *        …
         *       ]
         */
        exports.categories = function (params) {
            exec(null, null, "CommonServiceApi", "action_categories", params);
        };


        /**
         * 下拉刷新完成,通知native关闭刷新动画
         */
        exports.donePulldown = function () {
            exec(null, null, "CommonServiceApi", "action_donePulldown", new Array());
        };

        /**
         * 加载结束,通知native关闭加载转圈动画
         */
        exports.finishLoad = function () {
            exec(null, null, "CommonServiceApi", "action_finishLoad", new Array());
        };

        /**
         * 上拉加载完成,通知native关闭刷新动画
         */
        exports.donePullup = function (size) {
            var params = {
                params: size
            }
            exec(null, null, "CommonServiceApi", "action_donePullup", [params]);
        };


        /**
         * 日期时间选择控件
         * @param timemillis  设置的时间戳（用于修改），新增操作该参数可以不填。返回选择的时间结果。 PS:时间是格林威治时间，单位毫秒
         */
        exports.selectDatetime = function (success, error, timemillis) {
            var params = {
                timemillis: timemillis
            }
            exec(success, error, "CommonServiceApi", "action_datetime", [params]);
        };

        /**
         * 弹出输入框控件
         * @param limit  输入的文本字数限制， 返回内容
         */
        exports.inputText = function (success, error, limit) {
            var params = {
                limit: limit
            }
            exec(success, error, "CommonServiceApi", "action_inputText", [params]);
        };

        /**
         *  刷新评论
         * @param success
         * @param error
         */
        exports.refreshInteraction = function (success, error) {
            exec(success, error, "CommonServiceApi", "action_refreshInteraction", new Array());
        };

        /**
         * 原生Toast提示
         * @param url  页面url
         * @param toastMsg  toast的信息
         * @param isFinishActivity  是否关闭当前Activity界面
         */
        exports.nativeToastWithFinish = function (msg, finishActivity) {
            var p = {
                url: "",
                params:{
                    "toastMsg": msg,
                    "isFinishActivity": finishActivity
                }
            }
            exec(null, null, "CommonServiceApi", "action_news_finish_toast", [p]);
        };

        exports.getNewsFetchData = function (args, success, failure) {
            exec(success, failure, "CommonServiceApi", "action_NewsFetchData", args);
        };

    });
