angular.module('news.service.cordova', [])
  .service('cordovaService', function() {

    this.donePulldown = function() {
      if (!mCordovaSupport) return;
      try {
        if (mPlatformAndroid) {
          cordova.plugins.CommonServiceApi.donePulldown();
        } else if (mPlatformIOS) {
          cordova.plugins.FPlugin.actionDonePullDown(null, null);
        }
      } catch (e) {
        // alert(e)
      }
    }

    this.donePullup = function(size) {
      if (!mCordovaSupport) return;
      if (mPlatformAndroid) {
        cordova.plugins.CommonServiceApi.donePullup(size);
      } else if (mPlatformIOS) {
        cordova.plugins.FPlugin.actionDonePullUp(null, null);
      }
    }

    this.pushCategoriesData = function(data) {
      if (!mCordovaSupport) return;
      if (mPlatformAndroid) {
        cordova.plugins.CommonServiceApi.categories(data);
      } else if (mPlatformIOS) {
        cordova.plugins.FPlugin.initCategoryView(null, null, data);
        cordova.plugins.FPlugin.actionFinishLoad();
      }
    }

    this.refreshInteraction = function() {
      if (!mCordovaSupport) return;
      if (mPlatformAndroid) {
        cordova.plugins.CommonServiceApi.refreshInteraction(null, null);
      }
    }

    this.toast = function(msg) {
      if (!mCordovaSupport) return;
      try {
        if (mPlatformAndroid) {
          cordova.plugins.CommonServiceApi.nativeToastWithFinish(msg, false, "");
        } else if (mPlatformIOS) {
          cordova.plugins.FPlugin.toast(msg);
        }
      } catch (e) {
        // alert(e)
      }
    }

    this.toastAndFinish = function(msg) {
      if (!mCordovaSupport) return;
      if (mPlatformAndroid) {
        cordova.plugins.CommonServiceApi.nativeToastWithFinish(msg, true);
        cordova.plugins.CommonServiceApi.refreshInteraction(null, null);
      } else if (mPlatformIOS) {
        //cordova.plugins.FPlugin.toast( msg );
        cordova.plugins.FPlugin.actionClose(null, null, null, null);
      }
    }

    this.actionFinish = function() {
      if (!mCordovaSupport) return;
      if (mPlatformAndroid) {
        cordova.plugins.CommonServiceApi.nativeToastWithFinish("", false, "");
      } else if (mPlatformIOS) {
        cordova.plugins.FPlugin.actionClose(null, null, null, null);
      }
    }

    window.NativeToast = this.toast;

    /*******************************************************************************/
    /* Android only */

    this.followCommentForAndroid = function(comment) {
      if (!mCordovaSupport) return;
      if (mPlatformAndroid) {
        cordova.plugins.CommonServiceApi.pageJump("action_comment", comment, "");
      }
    }

    /*******************************************************************************/
    /* IOS only */

    this.addPullRefreshForIos = function() {
      if (!mCordovaSupport) return;
      if (mPlatformIOS) {
        cordova.plugins.FPlugin.addPullRefresh();
      }
    }

    this.addBottomInputForIos = function(limit, jsFunction, followComment) {
      if (!mCordovaSupport) return;
      if (mPlatformIOS) {
        cordova.plugins.FPlugin.addBottomInput(limit, jsFunction, followComment);
      }
    }

    this.allowURLJumpforIos = function() {
      if (!mCordovaSupport) return;
      if (mPlatformIOS) {
        cordova.plugins.FPlugin.allowURLJump();
      }
    }

    this.setRefreshTimeForIos = function(time) {
      if (!mCordovaSupport) return;
      if (mPlatformIOS) {
        cordova.plugins.FPlugin.sendCmd(null, null, 'action_setRefreshTime', time);
      }
    };

    this.newsFetchData = function(args, success, failure) {
      if (mCordovaSupport) {
        if (mPlatformAndroid) {
          if (mCordovaReady) {
            cordova.plugins.CommonServiceApi.getNewsFetchData(args, success, failure);
          } else {
            registerEventBus("News_newsFetchData", function(event) {
              if (EVENT_CORDOVA_READY === event) {
                cordova.plugins.CommonServiceApi.getNewsFetchData(args, success, failure);
              }
            });
          }
        }
      }
    };

  });
