angular.module('news.service.interaction', [])
  .service('interactionService', function() {

    var _buildPraiser = function(data) {
      return new Praiser(data.uid);
    };

    var _updatePraiser = function(src, dest) {
      dest.irt_id = src.irt_id;
      dest.irt_type = src.irt_type;
      dest.op_time = src.op_time;
    };


    var _insertOrUpdatePraiser = function(praisers, data) {
      if (data === undefined || data.uid === undefined) return;

      for (var i = 0; i < praisers.length; i++) {
        if (praisers[i].uid === data.uid) {
          _updatePraiser(data, praisers[i]);
          return;
        }
      }
      var newPraiser = _buildPraiser(data);
      _updatePraiser(data, newPraiser);
      praisers.push(newPraiser);
    };

    this.getNewsPraisersLatest = function(praisers, newsID, requestSize, callback) {
      if (newsID === undefined) {
        callback(FAILURE);
        return;
      }
      $.getJSON(HOST_SDP_INTERACTIONS + "interactions/object_irt_list/PRAISE/NEWS/OBJECT/" + newsID +
        "?size=" + requestSize, {},
        function(data) {
          log("getNewsPraisersLatest !!!");
          log(data);

          praisers.length = 0;

          if (data === undefined || data.items === undefined || data.items.length <= 0) {
            callback(EMPTY);
            return;
          }

          for (var i = 0; i < data.items.length; i++) {
            var item = data.items[i];
            _insertOrUpdatePraiser(praisers, item);
          }

          callback(SUCCESS);
        },
        function(data, statusCode) {
          callback(FAILURE);
          log("getNewsPraisersLatest :: error :: " + statusCode + " :: " + data);
        });
    };

    this.getNewsPraisersOlder = function(praisers, newsID, max_irt_id, requestSize, callback) {
      if (newsID === undefined || max_irt_id === undefined) {
        callback(FAILURE);
        return;
      }
      $.getJSON(HOST_SDP_INTERACTIONS + "interactions/object_irt_list/PRAISE/NEWS/OBJECT/" + newsID +
        "?size=" + requestSize + "&max_irt_id=" + max_irt_id, {},
        function(data) {
          log("getNewsPraisersOlder !!!");
          log(data);

          if (data === undefined || data.items === undefined || data.items.length <= 0) {
            callback(EMPTY);
            return;
          }

          for (var i = 0; i < data.items.length; i++) {
            var item = data.items[i];
            _insertOrUpdatePraiser(praisers, item);
          }

          callback(SUCCESS);
        },
        function(data, statusCode) {
          callback(FAILURE);
          log("getNewsPraisersOlder :: error :: " + statusCode + " :: " + data);
        });
    };

  });
