angular.module('news.service.localstore', [])
  .service('localstoreService', function() {

    this.restoreLocalJsonData = function(key) {
      if (mSupportLocalStorage) {
        var data = localStorage.getItem(key);
        if (data !== undefined) {
          var json = JSON.parse(data);
          if (json !== undefined) {
            return json;
          }
        }
      }

      return undefined;
    };


    /**
     * 本地缓存 新闻分类数据
     */
    this.storeCategories = function(categories) {
      if (mSupportLocalStorage) {
        localStorage.setItem(KEY_STORE_CATEGORIES, JSON.stringify(categories));
      }
    };

    /**
     * 恢复 本地缓存的 新闻分类数据
     * @returns {*}
     */
    this.restoreCategoriesData = function() {
      if (mSupportLocalStorage) {
        var restore = restoreLocalJsonData(KEY_STORE_CATEGORIES);
        if (mRestoredCategories) {
          return restore;
        }
      }
      return [];
    };

    /**
     * 恢复 本地缓存的 新闻已读数据
     * @returns {*}
     */
    this.restoreNewsReadMark = function() {
      if (mSupportLocalStorage) {
        var restore = restoreLocalJsonData(KEY_STORE_CATEGORY_NEWS_READ_MARK);
        if (restore !== undefined) {
          return restore;
        }
      }
      return [];
    };

    /**
     * 本地缓存 新闻分类数据
     */
    this.storeNewsReadMark = function(mark) {
      if (mSupportLocalStorage) {
        localStorage.setItem(KEY_STORE_CATEGORY_NEWS_READ_MARK, JSON.stringify(mark));
      }
    };

    /**
     * 本地缓存 新闻分类数据
     */
    this.storeCategoryNews = function(news) {
      if (mSupportLocalStorage) {
        localStorage.setItem(KEY_STORE_NEWS, JSON.stringify(news));
      }
    };
  });
