angular.module('news.service.praisers', [])
  .service('praisersService', ['$http', function($http) {
    /**
     * 获取点赞用户详情
     * @param newsID新闻ID
     * @param requestSize请求的大小
     * @param callback回调函数
     */
    this.getNewsPraisersLatest = function(newsID, requestSize, callback) {
      if (newsID === undefined) {
        callback(FAILURE);
        return;
      }
      $.getJSON(HOST_SDP_INTERACTIONS + "interactions/object_irt_list/PRAISE/NEWS/OBJECT/" + newsID +
        "?size=" + requestSize, {},
        function(data) {
          log("getNewsPraisersLatest !!!");
          log(data);

          cleanCurrentPraisers();

          if (data === undefined || data.items === undefined || data.items.length <= 0) {
            callback(EMPTY);
            return;
          }

          var uids = [];
          for (var i = 0; i < data.items.length; i++) {
            var item = data.items[i];
            insertOrUpdatePraiser(item);
            uids.push(item.uid);
          }
          updateCommentUserNameBatch(uids, function() {
            onEvent(EVENT_ELEMENT_REFRESH);
          });

          callback(SUCCESS);
        },
        function(data, statusCode) {
          callback(FAILURE);
          log("getNewsPraisersLatest :: error :: " + statusCode + " :: " + data);
        });
    };

  }]);
