/*------------------------------------------------------------------------------*/

var EVENT_ELEMENT_REFRESH = "event_element_refresh";
var EVENT_CORDOVA_READY = "event_cordova_ready";

function Event(id, callback) {
  this.id = id;
  this.callback = callback;
}

var mEventBus = [];

function insertOrUpdateEvent(event) {
  if (event.id === undefined) return false;

  if (mEventBus.length <= 0) {
    mEventBus.push(event);
    return;
  }

  var added = true;
  for (var i = 0, max = mEventBus.length; i < max; i++) {
    if (mEventBus[i].id == event.id) {
      mEventBus[i] = event;
      added = false;
      break;
    }
  }

  if (added) {
    mEventBus.push(event);
  }
}

function registerEventBus(id, callback) {
  insertOrUpdateEvent(new Event(id, callback));
}

function onEvent(event) {
  for (var i = 0; i < mEventBus.length; i++) {
    var item = mEventBus[i];
    if (item !== undefined) {
      item.callback(event);
    }
  }
}



function log(msg) {
  /*if (DEBUG)
    console.log(msg);*/
}

/**
 * 测试时间记录日志
 * @param msg 时间起始或结束信息 Start/End
 * @param caseId 用例ID
 */
function timeLog(caseId, msg) {
  //console.log("[ PerformanceTest ] Case " + caseId + " : " + msg + "--" + new Date().getTime());
  return new Date().getTime();
}



var mToastShowing = false;
var FastToast = function(message, callback) {
  var context = $('body'); //上下文
  var top = '150px'; //距容器上方的距离

  var toast = $("#global-toast");
  if (toast.length <= 0) {
    toast = $("<div id='global-toast'/>").appendTo(context);
    toast.css({
      position: 'fixed',
      'z-index': '99',
      'background-color': 'black',
      display: "none",
      color: 'white',
      'font-size': '15px',
      padding: '16px 10px',
      margin: '10px',
      opacity: 0.8,
      borderRadius: "4px"
    });
  }

  toast.text(message);
  top = top === null ? '150px' : top;
  var left = ($(window).width() - toast.width()) / 2 - 20;
  toast.css({
    top: top,
    left: left
  });

  var totalTime = 2000; //持续时间
  var fadeInTime = totalTime * 0.5;
  var fadeOutTime = totalTime - fadeInTime;

  if (mToastShowing) {
    toast.stop();
    toast.hide();
    toast.fadeIn(fadeInTime);
  } else {
    toast.fadeIn(fadeInTime);
    mToastShowing = true;
  }
  toast.delay(fadeInTime).fadeOut(fadeOutTime, function() {
    mToastShowing = false;

    if (callback !== undefined) {
      callback();
    }
  });
};

var jst = JSON.stringify;
