angular.module('widget.async.img', ['news.service.common'])
  .directive('asyncLoadImage', ['common',
    function($common) {
      return {
        restrict: 'E',
        replace: true,
        scope: {
          imgSrc: '@imgSrc',
          imgSize: '@imgSize'
        },
        template: '<img />',
        controller: ['$scope', '$element', '$attrs', function($scope, $element, $attrs) {
          var src = $scope.imgSrc;
          var size = $scope.imgSize;

          if (src) {
            var url = $common.convertImageURLWithSize(src, size);
            $element.attr('src', IMG_LOADING_SMALL);
            $.imageLoad(url, null, function() {
              $element.attr('src', this.src);
            }, function() {
              log("asyncImg error ::: " + url);
              $element.attr('url', IMG_NDLOGO);
            });
          } else {
            // 地址缺失无效
            $element.attr('src', IMG_NDLOGO);
          }
        }]
      };
    }
  ]);
