angular.module('widget.async.img.fit', ['news.service.common'])
  .directive('asyncImgFit', ['common',
    function($common) {
      return {
        restrict: 'E',
        replace: true,
        scope: {
          containerClass: '@containerClass',
          imgClass: '@imgClass',
          imgSrc: '@imgSrc',
          imgSize: '@imgSize',
          scaleType: "@scaleType"
        },
        template: '<div><img/></div>',
        controller: ['$scope', '$element', '$attrs', '$location', function($scope, $element, $attrs, $location) {
          var containerClass = $scope.containerClass;
          if (!containerClass) {
            containerClass = 'async-img-container';
          }
          var imgClass = $scope.imgClass;
          if (!imgClass) {
            imgClass = 'async-img';
          }
          var src = $scope.imgSrc;
          var size = $scope.imgSize;
          var scaleType = 0;
          if ($scope.scaleType && !isNaN($scope.scaleType)) {
            scaleType = $scope.scaleType;
          }

          $element.addClass(containerClass);
          var dw = document.documentElement.clientWidth - 20;
          var dh = 5 * dw / 17;

          var viewSize = size;

          if (+size !== 160) {
            $element.css("width", dw);
            $element.css("height", dh);
            scaleType = 2;
          }else {
            viewSize *= 0.5;
            $element.css("width", viewSize);
            $element.css("height", viewSize);
          }

          var img = $element.children(':first');
          img.addClass(imgClass);
          img.css("width", viewSize);
          img.css("height", viewSize);

          if (src) {
            var url = (function(){
              if (/^(?:https?:)?\/\/([^\/]+)(\/.+)$/i.test(src)) {
                return src;
              }

              return $common.convertImageURLWithSize(src, size);

            })();

            img.css("width", 80);
            img.css("height", 80);
            img.attr('src', IMG_LOADING_SMALL);
            $.imageLoad(url, null, function() {

              var h = this.height;
              var w = this.width;
              var sh, sw;

              // size = size * 0.5;

              switch (scaleType) {
                case 1:
                  if (h > w) {
                    sh = viewSize;
                    sw = viewSize * (w / h);
                  } else {
                    sw = viewSize;
                    sh = viewSize * (h / w);
                    if (viewSize > sh) {
                      $element.css('paddingTop', (viewSize - sh) * 0.4);
                    }
                  }
                  $element.css('background', '#ddd');
                  break;
                case 2:
                  sw = dw;
                  sh = dh;
                  break;
                default:
                  sh = viewSize;
                  sw = w / h * viewSize;
                  if (sw > viewSize) {
                    img.css('marginLeft', (sw - viewSize) * -0.5);
                  }
                  break;

              }

              img.attr('src', this.src);
              img.css('width', sw);
              img.css('height', sh);
            }, function() {
              img.closest('.list-news-img-layout').hide().parent().css('padding-bottom', 0);
              img.closest('.list-news-img-layout').siblings('.list-content').css('height', 'auto').find('.news-info').css('position', 'static');
            });

          } else {
            // 地址缺失无效
            img.closest('.list-news-img-layout').hide().parent().css('padding-bottom', 0);
            img.closest('.list-news-img-layout').siblings('.list-content').css('height', 'auto').find('.news-info').css('position', 'static');
          }
        }]
      };
    }
  ]);
