angular.module('widget.async.img.fit.screen', ['news.service.common'])
  .directive('asyncLoadImageFitScreen', ['common',
    function($common) {
      return {
        restrict: 'A',
        link: function($scope, $element, $attrs) {
          var src = $attrs.imgSrc;
          //var size = Math.max(document.documentElement.clientWidth, document.documentElement.clientHeight);
          var url = $common.convertImageURLWithSize(src, 960);
          $element.attr('src', IMG_LOADING_SMALL).addClass('loading-small');

          $.imageLoad(url, null, function() {
            //根据窗口的比例与图片的比例来确定
            //图片是根据宽度来等比缩放还是根据高度来等比缩放
            var realWidth = $scope.mGalleryImgWidth;
            var realHeight = $scope.mGalleryImgWidth * this.height / this.width;
            var ratio = $scope.mGalleryImgHeight / $scope.mGalleryImgWidth;

            if (this.height === 0 || this.width === 0) {
              realWidth = $scope.mGalleryImgWidth;
              realHeight = $scope.mGalleryImgHeight;
            } else if (this.height / this.width > ratio) {
              realWidth = $scope.mGalleryImgHeight * this.width / this.height;
              realHeight = $scope.mGalleryImgHeight;
            }

            $element.css('width', realWidth + "px");
            $element.css('height', realHeight + "px");
            $element.attr('src', this.src).removeClass('loading-small');
          }, function() {
            $element.attr('src', IMG_NDLOGO).addClass('loading-small');
          });
        }
      };
    }
  ]);
