angular.module('widget.async.load.img', ['news.service.common'])
  .directive('asyncLoadImage', ['common',
    function($common) {
      return {
        restrict: 'A',
        link: function($scope, $element, $attrs) {
          var src = $attrs.imgSrc;
          var size = $attrs.imgSize || 640;

          if (src) {
            var url = $common.convertImageURLWithSize(src, size);

            // 无需token，直接从内容服务取图
            $element.attr('src', IMG_LOADING_SMALL)
              .addClass('loading-small');

            $.imageLoad(url, null, function() {
              $element.attr('src', this.src)
                .removeClass('loading-small');
            }, function() {
              $element.attr('src', IMG_NDLOGO);
            });
          } else {
            // 地址缺失无效
            $element.attr('src', IMG_NDLOGO);

          }
        }
      };
    }
  ]);
