angular.module('service.util', [])
    .service('utilService', function () {

        //将1970 年 1 月 1 日至今的毫秒数转成日期时间格式
        // fm 格式说明
        //      0/null: xxxx-xx-xx xx:xx:xx 日期+时间
        //      1:xxxx-xx-xx xx:xx  日期+时间(不带秒数)
        //      2:xxxx-xx-xx    日期
        //      3:xx:xx:xx      时间
        //      4:  xx-xx xx:xx 日期+时间(不带年和秒数)
        this.formatDateTime = function (value, fm) {

            var d = new Date(value),
                mon = d.getMonth() + 1,
                date = d.getDate(),
                hour = d.getHours(),
                min = d.getMinutes(),
                sec = d.getSeconds();
            if (null === fm || 0 === fm || '0' === fm) {
                return d.getFullYear() + '-' + (mon < 10 ? '0' : '') + mon + '-' + (date < 10 ? '0' : '') + date + ' ' + (hour < 10 ? '0' : '') + hour + ':' + (min < 10 ? '0' : '') + min + ':' + (sec < 10 ? '0' : '') + sec;
            } else if (1 == fm || '1' == fm) {
                return d.getFullYear() + '-' + (mon < 10 ? '0' : '') + mon + '-' + (date < 10 ? '0' : '') + date + ' ' + (hour < 10 ? '0' : '') + hour + ':' + (min < 10 ? '0' : '') + min;
            } else if (2 == fm || '2' == fm) {
                return d.getFullYear() + '-' + (mon < 10 ? '0' : '') + mon + '-' + (date < 10 ? '0' : '') + date;
            } else if (3 == fm || "3" == fm) {
                return (hour < 10 ? '0' : '') + hour + ':' + (min < 10 ? '0' : '') + min + ':' + (sec < 10 ? '0' : '') + sec;
            } else if (4 == fm || "4" == fm) {
                return (mon < 10 ? '0' : '') + mon + '-' + (date < 10 ? '0' : '') + date + ' ' + (hour < 10 ? '0' : '') + hour + ':' + (min < 10 ? '0' : '') + min;
            }
        };


        //解析Url
        this.parseUrl = function (url) {
            var r =
            {
                protocol: /([^\/]+:)\/\/(.*)/i,
                host: /(^[^\:\/]+)((?:\/|:|$)?.*)/,
                port: /\:?([^\/]*)(\/?.*)/,
                pathname: /([^\?#]+)(\??[^#]*)(#?.*)/
            };

            var tmp, p, res = {};
            res.href = url;
            for (p in r) {
                tmp = r[p].exec(url);
                res[p] = tmp[1];
                url = tmp[2];
                if (url === "") {
                    url = "/";
                }
                if (p === "pathname") {
                    res.pathname = tmp[1];
                    res.search = tmp[2];
                    res.hash = tmp[3];
                }
            }
            console.log(url);
            return res;
        };

        //组装url字段，如果是本地则添加api/，否则直接返回url,
        this.convert_url = function (url, size) {
            //绝对路径直接返回
            if (/^http:\/\//ig.exec(url)) {
                return url; //以http://开头直接返回
            }
            else if (/^file:\/\//ig.exec(url)) {
                return url;
            }
            else if (/^ftp:\/\//ig.exec(url)) {
                return url;
            }
            //相对路径判断是否不是本地，如果是本地则添加api/

            /*  var path;
             try{
             path = getCsPath().path || '/notice';
             }catch(e){
             path = '/notice';
             }

             return CS_API_BASE+"/static" + path + "/" + url;

             */
            var pos = url.lastIndexOf(".");
            if (pos != -1) {
                //gif图片不支持缩放
                if (url.substr(pos + 1) == "gif")
                    return url;
            }

            //url是dentry_id

            if (mPlatformIOS) {
                return MUICordovaWebJSExport.getPhotoURLString(url, size);
            }
            if (mPlatformAndroid) {
                return JsHttpRequest.getImgUrl(url, size);
            }

            /* var pos = result.lastIndexOf(".");
             if (pos != -1) {
             //gif图片不支持缩放
             if (result.substr(pos + 1) == "gif")
             return result;
             }*/


        };

        this.log = function (txt) {
            if (DEBUG) {
                console.log(txt);
            }
        };

        this.goBack = function () {
            history.back();
        };

        /*
         *构造缩略图
         * 参数:
         * size：缩略图尺寸(80,120,160,240,480,640,960)
         * 返回值:缩略图地址
         */
        this.getThumbImgSize = function (path, size) {
            var pos = path.lastIndexOf(".");
            if (pos != -1) {
                //gif图片不支持缩放
                if (path.substr(pos + 1) == "gif")
                    return path;
            }
            return path + (size !== undefined ? "?size=" + size : "");
        };

        /**
         * 替换 字符串中的http链接
         * @param text
         * @returns {*}
         */
        this.replaceURLWithHTMLLinks = function (text) {
            /*
             Example:

             >>> GateOne.Utils.replaceURLWithHTMLLinks('Downloading http://foo.bar.com/some/file.zip');
             "Downloading <a href="http://foo.bar.com/some/file.zip">http://foo.bar.com/some/file.zip</a>"
             */
            var exp = /(\b(https?|ftp|file):\/\/[-A-Z0-9+&@#\/%?=~_|!:,.;]*[-A-Z0-9+&@#\/%=~_|])/ig;
            return text.replace(exp, "<a href='$1' target='_blank'>$1</a>");
        };

        /*
         *编辑器内容中的图片的解析
         * <img data-src="f53bbcf1-2371-4bf2-8f94-8d02a5c4e9da">
         * <---------------------replace to--------------------->
         * <img
         * src="http://betacs.101.com/v0.1/download?dentryId=f53bbcf1-2371-4bf2-8f94-8d02a5c4e9da"
         * data-src="f53bbcf1-2371-4bf2-8f94-8d02a5c4e9da"
         * >
         *
         * */
        this.editorImgParse = function (data) {
            var that = this;
            var sizes = [80, 120, 160, 240, 320, 480, 640, 960];
            var PATTERN_DATA_SRC = /data\-src="([0-9a-f]{8}(?:\-[0-9a-f]{4}){3}\-[0-9a-f]{12})"(?:\s+width="(\d+)")?(?:\s+height="(\d+)")?/g;
            return data.replace(PATTERN_DATA_SRC, function (_, id, h, w) {
                var minVue = (h || w) ? Math.min(h, w) : 160;
                var size = sizes.indexOf(minVue) === -1 ? 160 : minVue;
                return 'src="' + that.convert_url(id, size) + '" '+_;
            });

        };


        //  数组去重
        this.uniqueArray = function (array) {
            if (!array) {
                return [];
            }
            var n = {}, r = []; //n为hash表，r为临时数组
            for (var i = 0; i < array.length; i++) //遍历当前数组
            {
                if (!n[array[i]]) //如果hash表中没有当前项
                {
                    n[array[i]] = true; //存入hash表
                    r.push(array[i]); //把当前数组的当前项push到临时数组里面
                }
            }
            return r;
        };

        this.getPicExt = function (file) {
            if (file === undefined || file === "") return "";
            var pos = -1;
            if (isIOS()) {
                pos = file.lastIndexOf("ext=");
                if (pos != -1) return ("." + file.substr(pos + 4)).toLowerCase();
            }
            else {
                pos = file.lastIndexOf(".");
                if (pos != -1) return (file.substr(pos)).toLowerCase();
            }
            return "";
        };

        this.viewPic = function (imgsArray, index) {
            cordova.plugins.DeviceApi.picView(imgsArray, index);
        };

        this.performanceLog = function (id, txt) {
            if (DEBUG)
                console.log("[PerformanceTest - 通知公告] Case " + id + " : " + txt + " -- " + new Date().getTime());
        };
    });