/**
 * Created by lyp on 2015/4/29.
 */

$.extend({
    /*
     *构造图片地址
     * 参数:
     * path:服务器返回的图片路径
     * 返回值:图片地址
     */
    getImagePath: function(dentryId, size) {
        if (mPlatformIOS) {
            return MUICordovaWebJSExport.getPhotoURLString(dentryId, size);
        }
        if (mPlatformAndroid) {
            return JsHttpRequest.getImgUrl(dentryId, size);
        }
        //return CS_API_BASE+"/v0.1/static" + path;
    },

    /*
     *根据id构造图片地址
     * 参数:
     * imgId:服务器图片id
     * 返回值:图片地址
     */
    getImagePathById: function(imgId) {
        var cookie = $.getCookie("content_session");
        var params = cookie.split(",");
        return $.getImagePath(params[1] + "/" + imgId);
    },

    /*
     *构造缩略图
     * 参数:
     * size：缩略图尺寸(80,120,160,240,480,640,960)
     * 返回值:缩略图地址
     */
    getThumbImg: function(path, size) {
        var pos = path.lastIndexOf(".");
        if (pos != -1) {
            //gif不支持缩放
            if (path.substr(pos + 1) == "gif")
                return path;
        }
        return path + "?size=" + size;
    },

    /*
     *上传图片
     * 参数:
     * imgsrc : 源图片的URI
     * imgId: 设置图片ID
     * imgurlCallback:回调函数（var imgurlCallback = function(path){};),上传成功返回图片URL，失败返回"",可选
     */
    uploadImage: function(imgsrc, imgId, imgurlCallBack, uploadError) {
        if (imgsrc === undefined) {
            uploadError("");
            return;
        }
        /*
         //uuidw文件名
         var ext = imgsrc;
         var pos = imgsrc.lastIndexOf(".");
         if (pos != -1) {
         ext = ext.substr(pos);
         }
         else {
         ext = "";
         }
         */
        var fileName = imgId;

        //传送成功
        var fileTransferSuccess = function(result) {
            if (imgurlCallBack !== undefined) {
                var data = JSON.parse(result.response);
                var path = $.getImagePath(data['dentry_id'], 960);
                imgurlCallBack(path, data['dentry_id'], data['name']);
            }
        };

        //传送失败
        var fileTransferError = function(error) {
            var ErrorCode = ['CS/SESSION_IS_EMPTY', 'CS/SESSION_NOT_FOUND', 'CS/SESSION_EXPIRED', 'CS/SESSION_FORBIDDEN'];
            //判断session过期，重传
            if (error.body) {
                if (ErrorCode.indexOf(JSON.parse(error.body).code) !== -1) {
                    $.getSession(function(cookie) {
                        $.uploadImage(imgsrc, imgId, imgurlCallBack);
                    }, uploadError(imgsrc));
                } else {
                    uploadError(imgsrc);
                }
                // uploadError(imgsrc);
                return;
            } else {
                uploadError(imgsrc);
            }

            // if (uploadError !== undefined) {
            //     uploadError(imgsrc);
            // }
        };
        //获取session
        $.sessionFilter(function(cookie) {
            var cookieParams = cookie.split(",");
            var session = cookieParams[0];
            var path = cookieParams[1];

            //设置上传参数
            var fileUploadOptions = new FileUploadOptions();
            fileUploadOptions.fileKey = "file";
            fileUploadOptions.fileName = fileName;

            //文件类型
            fileUploadOptions.mimeType = "text/plain";

            //设置其他参数
            var params = {};
            params.scope = 1;
            params.path = path;
            params.name = fileName;
            fileUploadOptions.params = params;

            //服务地址
            var url = CS_API_BASE + '/upload?session=' + session;

            //上传
            var fileTransfer = new FileTransfer();
            fileTransfer.upload(imgsrc, encodeURI(url), fileTransferSuccess, fileTransferError, fileUploadOptions);
        }, fileTransferError);
    }

});