angular.module('widget.async.img', ['service.util'])
    /**
     *图片预加载，若加载失败，则显示默认logo
     */
    .directive('asyncImg', ['utilService', function (utils) {
        return {
            restrict: 'E',
            replace: true,
            scope: {
                imgSrc: '@imgSrc',
                imgSize: '@imgSize'
            },
            template: '<img />',
            controller: ['$scope', '$element', function ($scope, $element) {
                var src = $scope.imgSrc;
                var size = $scope.imgSize;

                $element.css("width", size);
                $element.css("height", size);

                if (src) {
                    var url;
                    // 地址有效
                    if (( /^file:\/\//ig.exec(src) ) ||
                        ( /^\/private\//ig.exec(src) ) ||
                        ( /^\/Users\//ig.exec(src) ) ||
                        ( /^\/Private\//ig.exec(src) ) ||
                        ( /^\/users\//ig.exec(src) ) ||
                        ( /^assets-library:\/\//ig.exec(src) ) ||
                        ( /^http:\/\//ig.exec(src) ) ||
                        ( /^https:\/\//ig.exec(src) ) ||
                        ( /^ftp:\/\//ig.exec(src) )) {
                        // 绝对地址，直接加载
                        url = src;
                    } else {
                        // 无需token，直接从内容服务取图
                        var cookie = $.getCookie("content_session");
                        if (cookie)
                        {
                            var params = cookie.split(",");
                            url = CS_API_BASE+"/static" + params[1] + "/" + src + (size !== undefined ? "?size=" + size : "");
                        }

                        else
                        {
                            //在PC web中默认生产环境的path
                            url  = CS_API_BASE+"/static/notice/" + src + (size !== undefined ? "?size=" + size : "");
                        }
                    }
                    $element.attr('src', "./imgs/loading_small.gif");
                    $.imageLoad(url, null, function () {
                        $element.attr('src', this.src);
                    }, function () {
                        utils.log("loadimg error ::: " + url);
                        $element.attr('src', "./imgs/nd_logo.jpg");
                    });
                } else {
                    // 地址缺失无效
                    $element.attr('src', "./imgs/nd_logo.jpg");
                }
            }]
        };
    }]);