angular.module('widget.async.img.fit', ['service.util'])
    /**
     *图片预加载，若加载失败，则显示默认logo
     */
    .directive('asyncImgFit', ['utilService', function (utils) {
        return {
            restrict: 'E',
            replace: true,
            scope: {
                containerClass: '@containerClass',
                imgClass: '@imgClass',
                imgSrc: '@imgSrc',
                imgSize: '@imgSize'
            },
            template: '<div><img/></div>',
            controller: ['$scope', '$element', function ($scope, $element) {
                var containerClass = $scope.containerClass;
                if (!containerClass) {
                    containerClass = 'async-img-container';
                }
                var imgClass = $scope.imgClass;
                if (!imgClass) {
                    imgClass = 'async-img';
                }
                var src = $scope.imgSrc;
                var size = $scope.imgSize;

                $element.addClass(containerClass);
                $element.css("width", size);
                $element.css("height", size);

                var img = $element.children(':first');
                img.addClass(imgClass);
                img.css("width", size);
                img.css("height", size);

                var url;
                if (src) {
                    // 地址有效
                    if (( /^file:\/\//ig.exec(src) ) ||
                        ( /^\/private\//ig.exec(src) ) ||
                        ( /^\/Users\//ig.exec(src) ) ||
                        ( /^\/Private\//ig.exec(src) ) ||
                        ( /^\/users\//ig.exec(src) ) ||
                        ( /^assets-library:\/\//ig.exec(src) ) ||
                        ( /^http:\/\//ig.exec(src) ) ||
                        ( /^https:\/\//ig.exec(src) ) ||
                        ( /^ftp:\/\//ig.exec(src) )) {
                        // 绝对地址，直接加载
                        url = src;
                    } else {
                        // 无需token，直接从内容服务取图
                        url = CS_API_BASE+"/static/notice/" + src + (size !== undefined ? "?size=" + size : "");
                    }
                    img.attr('src', "./imgs/loading_small.gif");
                    $.imageLoad(url, null, function () {
                        var h = this.height;
                        var w = this.width;
                        var sh, sw;
                        if (h > w) {
                            sh = size;
                            sw = size * (w / h);
                        } else {
                            sw = size;
                            sh = size * (h / w);
                            if (size > sh) {
                                $element.css('paddingTop', (size - sh) * 0.4);
                            }
                        }

                        utils.log("asyncImgFit :: " + sw + " , " + sh);

                        img.attr('src', this.src);
                        img.css('width', sw);
                        img.css('height', sh);

                    }, function () {
                        utils.log("loadimg error ::: " + url);
                        img.attr('src', "./imgs/nd_logo.jpg");
                    });

                } else {
                    // 地址缺失无效
                    img.attr('src', "./imgs/nd_logo.jpg");
                }
            }]
        };
    }]);