/**
 * Created by lyp on 2015/4/7.
 */
var handleError = function(image) {
  var src = image.src;
  // setTimeout(function() {
  //   var count = +image.attributes.count.value;
  //   count -= 1;
  //   image.attributes.count.value = count;
  //   if (count) {
  //     image.src = src.replace(/size=960/, 'size=80');
  //   }
  // }(), 1000)
  image.src = src.replace(/size=960/, 'size=80');
};
angular.module('notice.new', ['service.util', 'service.language'])
  .controller('newCtrl', ['$scope', 'utilService', '$translate',
    function($scope, utils, $translate) {

      var noticeId = $.getUrlParam('noticeId');

      var originalHeight = document.documentElement.clientHeight;

      var isForward = false; //是否为转发公告;
      var hasHTML = false; //原公告内容是否有HTML标签

      function getNoticeData(noticeId, callback) {
        // 无图片
        // noticeId = '572c4b3fa3105f06f33e2e81';
        // 一张图
        // noticeId = '575e1ac6a3105f06f33e2f54';
        // 多张图片
        // noticeId = '5721a990a3105f06f33e2e6a';
        if (!noticeId) {
          return;
        }
        var req = {};
        var vorgId = g_userInfo.org_exinfo.v_org_id;
        var orgId = g_userInfo.org_id;
        var url = '/received_notices/' + noticeId;
        if (vorgId) {
          req.orgId = orgId;
          req.v_org_id = vorgId;
        }
        $.getJSON(url, req, function(data) {
          callback(data);
        });
      }

      function sliceBytes(value, length) {
        var n = value.length;
        var i;
        var sofar = 0;
        var ellipsis = '…';

        for (i = 0; ++sofar, i < n; i++) {
          if (value.charCodeAt(i) > 255) {
            ++sofar;
          }

          if (sofar > length) {
            return value.substr(0, i) + ellipsis;
          } else if (sofar === length) {
            return value.substr(0, i + 1) + ((i < n - 1) ? ellipsis : '');
          }
        }

        return value.substr(0, length);
      }

      function decodeEntities(s) {
        var str, temp = document.createElement('p');
        temp.innerHTML = s;
        str = temp.textContent || temp.innerText;
        temp = null;
        return str;
      }

      $scope.mScrollerHeight = originalHeight;
      //判断是否android设备
      $scope.isAndroidDevice = function() {
        return isAndroidOrIOS();
      };

      //发送通知json格式
      $scope.noticeData = {
        "title": "",
        "content": "",
        "target_nodes": [],
        "publisher": "",
        "ack_type": 0,
        "images": [],
        "status": 1
      };

      //等待获取用户信息
      function _init() {
        if (g_userInfo.user_id) {
          //组织节点
          $scope.org = {
            "name": $translate.instant('PLEASE_CHOOSE_NODE'),
            "id": ""
          };
          var userInfo = g_userInfo;
          $scope.noticeData.publisher = userInfo.nick_name || userInfo.org_exinfo.real_name || userInfo.org_exinfo['org.real_name'] || userInfo.user_name || userInfo.user_id;
          if (noticeId) {
            getNoticeData(noticeId, function(noticeDetail) {
              $scope.noticeData.title = noticeDetail.title;
              $scope.noticeData.content = noticeDetail.content;
              $scope.noticeData.images = noticeDetail.images;
              $scope.uploadObjs = noticeDetail.images.map(function(dentryId) {
                return {
                  id: dentryId,
                  dentryId: dentryId,
                  fromForward: true,
                  localSrc: $.getImagePath(dentryId, 80),
                  serverSrc: $.getImagePath(dentryId, 80),
                  status: 'success'
                };
              });
              $scope.successImg = [];
              // $scope.uploadObjs.forEach(function(obj) {
              //   $scope.successImg.push(obj.localSrc);
              // });
              $scope.inited = true;
              isForward = true;
              hasHTML = /<|>/.test(noticeDetail.content);
              $scope.$apply();
            });

          } else {
            $scope.inited = true;
            $scope.$apply();
          }
        } else {
          setTimeout(function() {
            _init();
          }, 200);
        }
      }

      ////获取默认用户名

      $scope.inited = false;
      $scope.init = function() {
        _init();
      };

      function stripRequestScript() {
        $scope.noticeData.title = $scope.noticeData.title.stripScript();
        $scope.noticeData.content = isForward && hasHTML ? $scope.noticeData.content : $scope.noticeData.content.stripScript();
        $scope.noticeData.publisher = $scope.noticeData.publisher.stripScript();
      }



      //通知公告格式检查
      $scope.CheckSendNotice = function() {
        var errorInfo = "";
        //$scope.org.id = '485331318757';
        //$scope.org.id = '485331322859';
        if ($scope.org.id.length <= 0) errorInfo = $translate.instant('VALIDATION_SEND_TO');
        else if ($scope.noticeData.title === "") errorInfo = $translate.instant('VALIDATION_TITLE');
        else if (!$scope.noticeData.title) errorInfo = $translate.instant('VALIDATION_TITLE_INVALID');
        else if ($scope.noticeData.content === "") errorInfo = $translate.instant('VALIDATION_CONTENT');
        else if (!$scope.noticeData.content) errorInfo = $translate.instant('VALIDATION_CONTENT_INVALID');
        else if ($scope.noticeData.publisher === "") errorInfo = $translate.instant('VALIDATION_PUBLISHER');
        else if (!$scope.noticeData.publisher) errorInfo = $translate.instant('VALIDATION_PUBLISHER_INVALID');

        if (errorInfo !== "") {
          NativeToast(errorInfo);
          return;
        }

        var loadingIndex = [];
        for (var i in $scope.uploadObjs) {
          var obj = $scope.uploadObjs[i];
          if (obj.status != "success") {
            loadingIndex.push(i);
          }
        }

        //检查图片是否上传完毕
        if (loadingIndex.length !== 0) {
          $("BODY").popup({
            title: $translate.instant('UPLOAD_IMAGE'),
            message: $translate.instant(loadingIndex.length > 1 ? 'UPLOAD_IMAGE_MESSAGES' : 'UPLOAD_IMAGE_MESSAGE', {
              number: loadingIndex.length
            }),
            cancelText: $translate.instant('UPLOAD_IMAGE_CANCEL'),
            cancelClass: "button button-positive",
            cancelCallback: function() {
              //放弃
              if (loadingIndex.length === 0) return;
              //从尾部开始删除，防止数组错序删除错误
              for (var i = loadingIndex.length - 1; i >= 0; i--) {
                $scope.uploadObjs.splice(loadingIndex[i], 1);
              }
              $scope.reHeight();
              $scope.$apply();
              $scope.sendNotice();
            },
            doneText: $translate.instant('UPLOAD_IMAGE_LOADING'),
            doneClass: "button button-positive",
            doneCallback: function() {
              //等待
              return;
            }
          });
        } else {
          utils.performanceLog("#0019", "start");
          $scope.sendNotice();
        }
      };

      //发送通知公告请求
      $scope.sendNotice = function() {
        //判断合法性
        $scope.noticeData.target_nodes = [];
        $scope.noticeData.target_nodes.push($scope.org.id);
        //清空images
        $scope.noticeData.images = [];
        for (var i in $scope.uploadObjs) {
          var obj = $scope.uploadObjs[i];
          if (obj.status == "success")
            $scope.noticeData.images.push(obj.dentryId);
        }

        //过滤script脚本
        stripRequestScript();

        $scope.noticeData.summary = sliceBytes(decodeEntities($scope.noticeData.content.replace(/<script.*?>.*?<\/script>/ig, '')), 200);

        $scope.noticeData.content = isForward && hasHTML ? $scope.noticeData.content : utils.replaceURLWithHTMLLinks($scope.noticeData.content).replace(/\n/g, '</br>');

        //请求服务端
        var url = "/notices";
        var vorgId = g_userInfo.org_exinfo.v_org_id;
        var orgId = g_userInfo.org_id;
        if (vorgId) {
          url += '?orgId=' + orgId + '&v_org_id=' + vorgId;
        }
        $.postJSON(url, $scope.noticeData, function(responce) {
          $scope.noticeData.summary = "";
          $scope.noticeData.title = "";
          $scope.noticeData.content = "";
          $scope.noticeData.target_nodes = [];
          $scope.noticeData.publisher = g_userInfo.nick_name || g_userInfo.org_exinfo.real_name || g_userInfo.org_exinfo['org.real_name'] || g_userInfo.user_name || g_userInfo.user_id;
          $scope.noticeData.images = [];
          $scope.uploadObjs = [];
          $scope.cloneObjs = [];
          $scope.successImg = [];
          $scope.org.name = $translate.instant("PLEASE_CHOOSE_NODE");
          $scope.org.id = "";
          $scope.$apply();
          noticeUnblockUI();
          utils.performanceLog("#0019", "end");
          //设置查看查阅详情时间
          $scope.setCheckReminder(responce.id);

        }, function(responce) {
          noticeUnblockUI();
        });

        noticeBlockUI($translate.instant('MESSAGE_SENDING'));
      };

      $scope.reHeight = function() {
        var dis = 0;
        if ($scope.uploadObjs.length >= 3) dis += 56;
        if ($scope.uploadObjs.length >= 8) dis += 56;

        $scope.mScrollerHeight = originalHeight + dis;
      };


      $scope.uploadObjs = [];
      $scope.successImg = []; //用来存储已经上传成功的图片了。
      $scope.failImg = []; //存储上传失败的图片
      function addSuccessImg(src) {
        //上传成功过的图片，push到数组中去，去重successImg
        if (!isInSuccessImg(src)) {
          $scope.successImg.push(src);
        }
      }

      function removeSuccessImg(src) {
        //去除successImg中的图片
        var imgIndex = isInSuccessImg(src);
        if (imgIndex) {
          $scope.successImg.splice(+imgIndex, 1);
        }
      }

      function isInSuccessImg(src) {
        var index = $scope.successImg.indexOf(src);
        return index === -1 ? false : index + '';
      }

      //上传多张图片
      $scope.uploadProcess = function(imgs) {
        if (imgs === undefined) return;
        if (imgs.length === 0) return;

        // 如果成功的图片有不在本地上传中的，从上传成功中删除？
        for (var i = 0; i < $scope.successImg.length; i++) {
          if (imgs.indexOf($scope.successImg[i]) === -1) {
            $scope.successImg.splice(i, 1);
            i--;
          }
        }

        $scope.cloneObjs = [];
        $scope.uploadObjs.forEach(function(obj) {
          $scope.cloneObjs.push(obj);
        });

        // 把非转发的删掉了
        for (var i = 0; i < $scope.uploadObjs.length; i++) {
          if (!$scope.uploadObjs[i].fromForward) {
            $scope.uploadObjs.splice(i, 1);
            i--;
          }
        }

        // 循环本地上传的
        for (var j in imgs) {
          // 如果这个本地上传的图片在成功中了
          var index = isInSuccessImg(imgs[j]);
          if (index) {
            $scope.cloneObjs.forEach(function(item) {
              if (item.localSrc === imgs[j]) {
                $scope.uploadObjs.push(item);
                return false;
              }
            });
            continue;
          }


          var imgObj = {
            id: "",
            localSrc: "",
            status: "",
            serverSrc: ""
          };
          imgObj.id = $.getUUID() + utils.getPicExt(imgs[j]);
          imgObj.localSrc = imgs[j];
          imgObj.status = "upload";
          imgObj.serverSrc = "./imgs/loading_small.gif";
          var obj = imgObj;
          $scope.uploadObjs.push(obj);
        }

        //重新计算高度
        $scope.reHeight();
        $scope.$apply();

        //图片上传成功
        var uploadSuccess = function(path, dentryId, name) {
          /* var resId = "";
           var pos = path.lastIndexOf("/");
           if (pos != -1) {
           resId = path.substr(pos + 1);
           }
           else return;*/
          for (var k in $scope.uploadObjs) {
            var obj = $scope.uploadObjs[k];
            if (obj.id == name.replace(/\(.+\)/ig, '')) {
              //成功的时候，添加到数组中
              addSuccessImg(obj.localSrc);
              //如果有在失败中，从失败中移除
              var imgIndex = $scope.failImg.indexOf(obj.localSrc);
              if (imgIndex) {
                $scope.failImg.splice(+imgIndex, 1);
              }
              obj.dentryId = dentryId;
              obj.status = "success";
              obj.serverSrc = path;
              utils.performanceLog("#0024", "a picture has been upload");
              break;
            }
          }

          $scope.$apply();
        };

        //图片上传失败
        var uploadFailed = function(failSrc) {
          //获取图片ID
          var failId;
          for (var m in $scope.uploadObjs) {
            var obj = $scope.uploadObjs[m];
            if (obj.localSrc == failSrc && obj.status != "success" && $scope.failImg.indexOf(obj.localSrc) === -1) {
              failId = obj.id;
              $scope.failImg.push(obj.localSrc);
              utils.performanceLog("#0024", "a picture uploading failed");
              break;
            }
          }

          if (!failId) return;

          var pos = failSrc.lastIndexOf("/");
          if (pos == -1) return;
          var srcName = failSrc.substr(pos + 1);
          var showHtml = $translate.instant('UPLOAD_IMAGE_FAILED_MESSAGE');

          //询问是否重传

          $("BODY").popup({
            title: $translate.instant('UPLOAD_IMAGE_FAILED'),
            message: showHtml,
            cancelText: $translate.instant('UPLOAD_IMAGE_CANCEL'),
            subtitle: "[" + srcName + "]",
            cancelClass: "button button-positive",
            cancelCallback: function() {
              //删除图片上传队列
              for (var i in $scope.uploadObjs) {
                var obj = $scope.uploadObjs[i];
                if (obj.id == failId) {
                  $scope.uploadObjs.splice(i, 1);
                  break;
                }
              }
              $scope.reHeight();
              $scope.$apply();
            },
            doneText: $translate.instant('UPLOAD_IMAGE_RESEND'),
            doneClass: "button button-positive",
            doneCallback: function() {
              //重传图片
              $.uploadImage(failSrc, failId, uploadSuccess, uploadFailed);
            }
          });
        };

        for (var n in $scope.uploadObjs) {
          var obj2 = $scope.uploadObjs[n];
          if (!isInSuccessImg(obj2.localSrc)) {
            $.uploadImage(obj2.localSrc, obj2.id, uploadSuccess, uploadFailed);
          }

        }

      };

      //获取指定尺寸缩略图
      $scope.getSpecifyThumb = function(src) {
        return utils.convert_url(src, 80);
      };

      $scope.curSelImg = [];
      $scope.uploadImgs = {};
      var maxSize = 9;
      //cordova打开本地图片
      $scope.checkNetwork = function() {
        if (isAndroid()) {
          if (webView.isNetworkAvailable()) {
            $scope.choosePic();
          } else {
            NativeToast($translate.instant('MESSAGE_NET_WORK_PROBLEM'));
          }
        } else {
          if (MUICordovaWebJSExport.getNetworkAvaible()) {
            $scope.choosePic();
          } else {
            NativeToast($translate.instant('MESSAGE_NET_WORK_PROBLEM'));
          }

        }
      };

      $scope.choosePic = function() {
        $scope.curSelImg = [];
        $scope.uploadObjs.forEach(function(item) {
          Object.keys(item).forEach(function(key) {
            if (key === 'localSrc') {
              $scope.curSelImg.push(item.localSrc);
            }
          });
        });

        //判断图片是否太多
        if ($scope.uploadObjs.length >= maxSize) {
          NativeToast($translate.instant('VALIDATION_MAXSIZE', {
            number: maxSize
          }));
          return;
        }
        var successCallback = function(results) {
          if (results[0] === undefined) return;
          utils.performanceLog("#0024", "upload picture start");
          $scope.uploadProcess(results);
        };
        var errorCallback = function(error) {
          //NativeToast($translate.instant('MESSAGE_SELECT_IMAGE_FAILED'));
        };
        cordova.plugins.DeviceApi.imageChoose(successCallback, errorCallback, $scope.curSelImg, 9, "#ff0000", '#ffffff');
      };

      $scope.isAddPicShowed = function() {
        return $scope.uploadObjs.length < 9;
      };

      //删除图片
      $scope.delImage = function(imgId) {
        var isSuccess = false;
        for (var i in $scope.uploadObjs) {
          var obj = $scope.uploadObjs[i];
          if (obj.id == imgId) {
            removeSuccessImg(obj.localSrc);
            $scope.uploadObjs.splice(i, 1);
            $scope.reHeight();
            if (obj.status == "success") isSuccess = true;
            break;
          }
        }

        var delSuccess = function() {
          return;
        };

        var delError = function(error) {
          utils.log(error);
        };

        if (isSuccess) $.deleteFile(imgId, delSuccess, delError);
      };

      //保存预览数据
      $scope.saveData = function() {

        var errorInfo = "";
        if ($scope.noticeData.title === undefined) errorInfo = $translate.instant('VALIDATION_TITLE_INVALID');
        else if ($scope.noticeData.content === undefined) errorInfo = $translate.instant('VALIDATION_CONTENT_INVALID');
        else if ($scope.noticeData.publisher === undefined) errorInfo = $translate.instant('VALIDATION_PUBLISHER_INVALID');

        if (errorInfo !== "") {
          NativeToast(errorInfo);
          return;
        }

        var params = {
          "title": $scope.noticeData.title,
          "content": $scope.noticeData.content,
          "publisher": $scope.noticeData.publisher,
          "images": []
        };

        // if (isForward) {
        //   params.images = $scope.noticeData.images.map(function(dentryId) {
        //     return $.getImagePath(dentryId, 480);
        //   });
        // }

        for (var i in $scope.uploadObjs) {
          var obj = $scope.uploadObjs[i];
          if (obj.status == "success" && !obj.fromForward && isAndroid())
            params.images.push('file:///' + obj.localSrc);
          else if (obj.status == "success") {
            params.images.push(obj.localSrc);
          }
        }


        if (isIOS()) {
          switchToPageIOS("/preview.html", false, "setPreviewData", JSON.stringify(params));
          return;
        }

        switchToPage("action_post_notice_preview", "/preview.html", params);
      };

      $scope.chooseOrg = function() {
        var id = "#0021";
        if (isFirstLogon) id = "#0020";
        utils.performanceLog(id, "start");
        if (isIOS()) {
          switchToPageIOS("/orgTree.html", false);
          return;
        }
        switchToPage("action_notice_org", "/orgTree.html");
      };

      window.updateOrgParams = function(response) {
        var params = $.parseJSON(response);
        //if (params.id && params.name) {
        $scope.org = params;
        $scope.$apply();
        //}

      };

      Date.prototype.Format = function(fmt) { //author: meizz
        var o = {
          "M+": this.getMonth() + 1, //月份
          "d+": this.getDate(), //日
          "h+": this.getHours(), //小时
          "m+": this.getMinutes(), //分
          "s+": this.getSeconds(), //秒
          "q+": Math.floor((this.getMonth() + 3) / 3), //季度
          "S": this.getMilliseconds() //毫秒
        };
        if (/(y+)/.test(fmt)) fmt = fmt.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
        for (var k in o)
          if (new RegExp("(" + k + ")").test(fmt)) fmt = fmt.replace(RegExp.$1, (RegExp.$1.length == 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));
        return fmt;
      };

      $scope.getDefaultDate = function() {
        var today = new Date();
        var timestamp = window.localStorage.getItem('timestamp_minus');
        timestamp = timestamp ? +timestamp : 0;
        var tomorrow_seconds = (today.getTime() + 1000 * 60 * 60 * 24) + timestamp;
        //精确到当前分钟数
        today.setTime(parseInt(tomorrow_seconds / 60000) * 60000);
        return today;
      };

      window.onWebviewWillUpdate = function() {
        $scope.$apply();
      };

      window.inputDateTime = function() {
        if ($scope.androidDate) {
          webView.showDateDialog($scope.androidDate.getTime());
        } else {
          webView.showDateDialog(new Date().getTime() + 1000 * 60 * 60 * 24);
        }
      };

      window.setTime = function(time) {
        var date = new Date();
        date.setTime(time);
        $("#datetimelocal").val(date.Format("yyyy-MM-dd hh:mm"));
        $scope.androidDate = date;
      };

      //设置查看查阅详情时间页面
      var setCheckReminderHtml = function() {
        var timeLabel = $translate.instant('TIME') + ':';
        if (isAndroid()) {
          return '<label class="item item-input card"><div class="input-label">' + timeLabel + '</div><input id = "datetimelocal" type="text" readonly="true" onclick="inputDateTime()" /> </label>';
        }
        return '<label class="item item-input"><div>' + timeLabel + '</div>&nbsp;&nbsp;&nbsp;<input style="line-height: 27px;" type="datetime-local" id="datetimelocalios"></label>';
      };

      //设置查看查阅详情时间
      $scope.setCheckReminder = function(noticeId) {
        var defaultDate = $scope.getDefaultDate();
        var currentDate = new Date();
        $scope.iosDate = defaultDate;

        $scope.androidDate = defaultDate;

        $("BODY").popup({
          title: '<div>' + $translate.instant('MESSAGE_NOTICE_SEND_SUCCESS') + '</div><div>' + $translate.instant('MESSAGE_SET_VIEWING_TIME') + '</div>',
          message: setCheckReminderHtml(),
          cancelText: $translate.instant('CANCEL'),
          cancelClass: "button button-positive",
          doneText: $translate.instant('COMMIT'),
          doneClass: "button button-positive",
          donePre: function() {
            if (isAndroid()) {
              if ($scope.androidDate === null || !$("#datetimelocal").val()) {
                NativeToast($translate.instant('VALIDATION_VIEWING_TIME_EMPTY'));
                return false;
              }
              if ($scope.androidDate.getTime() <= currentDate.getTime()) {
                NativeToast($translate.instant('VALIDATION_VIEWING_TIME_NOT_VALID'));
                return false;
              }
              return true;
            } else {
              if ($("#datetimelocalios").val() === "") {
                NativeToast($translate.instant('VALIDATION_VIEWING_TIME_EMPTY'));
                return false;
              }
              var tmpTime = new Date($("#datetimelocalios").val()).getTime() - 8 * 60 * 60 * 1000;
              if (tmpTime <= currentDate.getTime()) {
                NativeToast($translate.instant('VALIDATION_VIEWING_TIME_NOT_VALID'));
                return false;
              }
              $scope.iosDate.setTime(tmpTime);
              return true;
            }
          },
          doneCallback: function() {
            var timeCount = 0;
            if (isAndroid()) {
              timeCount = $scope.androidDate.getTime();
            } else {
              timeCount = $scope.iosDate.getTime();
            }

            NativeToast($translate.instant('MESSAGE_SEND_SUCCESS'));
            var req = {
              start_at: timeCount
            };
            var vorgId = g_userInfo.org_exinfo.v_org_id;
            var orgId = g_userInfo.org_id;
            if (vorgId) {
              req.orgId = orgId;
              req.v_org_id = vorgId;
            }
            $.postJSON("/notices/" + noticeId + "/receipts/reminders", req, function(responce) {
              NativeToast($translate.instant('MESSAGE_SET_SUCCESS'));
            }, function(responce) {
              response && response.message && NativeToast($translate.instant('MESSAGE_SET_FAILED'));
            });
          },
          onShow: function(pop) {
            if (isAndroid()) {
              $("#datetimelocal").val($scope.getDefaultDate().Format("yyyy-MM-dd hh:mm"));
            } else {
              $("#datetimelocalios").val($scope.iosDate.Format("yyyy-MM-ddThh:mm"));
            }
          }
        });
      };
    }
  ]);

//callCordova(function(){
//    var params = [
//        {
//            "menu": "已发送",
//            "param": "sended",
//            "url": ASSETS_BASE + "/sendList.html",
//            "addRefresh": true
//        }
//    ];
//    if (isIOS()) {
//        cordova.plugins.FPlugin.initMenuViewEx(null, null, params);
//        return;
//    }
//    cordova.plugins.CommonServiceApi.pageMenu(params);
//});
