/**
 * Created by lyp on 2015/4/23.
 */

var g_org_id;
var v_org_id;

angular.module('notice.org', ['service.util', 'widget.finish.repeat', 'service.language'])
  //组织节点选择控制器
  .controller('orgCtrl', ['$scope', 'utilService', 'orgDataService', '$rootScope', '$timeout', '$translate',
    function($scope, utils, dataService, $rootScope, $timeout, $translate) {


      function waitForUserinfo() {
        if (g_userInfo.user_id) {
          g_org_id = g_userInfo.org_id;
          v_org_id = g_userInfo.org_exinfo.v_org_id;
          _init();
        } else {
          setTimeout(function() {
            waitForUserinfo();
          }, 200);
        }
      }

      waitForUserinfo();
      _bindFunctions();
      //这个函数要同步，不用等待用户信息，否则nodeInit会无定义

      function _init() {
        $scope.isshowuser = false; //  是否要显示组织下用户
        $scope.isread = true; //  判断当前显示的是否为已阅用户
        $scope.curClickedBtnID = "btnRead"; //  保存当前点击的按钮id(btnRead btnUnread)
        $scope.inited = false; //  判断组织架构是否已刷新
        $scope.lastCheckNode = null;
        $rootScope.nodeLoaded = false;

        _intRootNode();
        //_bindFunctions();
      }

      function _intRootNode() {
        //  初始化根节点
        var root = $scope.node = {
          id: 0,
          name: $translate.instant('ROOT_NODE'),
          level: 0
        };
        dataService.getNodes(0, 0, function(data) {
          root.status = 'expanded';
          root.nodes = data;
          $scope.inited = true;
          var id = "#0021";
          if (isFirstLogon) {
            id = "#0020";
          }
          utils.performanceLog(id, "end");
          //$scope.$apply();
        }, _failure);
      }

      function _bindFunctions() {
        $scope.getBtnCurrentStyle = _getBtnCurrentStyle;
        $scope.select = _select;
        $scope.toggle = _toggle;
        $scope.read = _read;
        $scope.unRead = _unRead;
        $scope.userNode = _userNode;
        $scope.nodeInit = _nodeInit;
      }


      //  根据当前点击的按钮返回按钮样式 (用普通button实现类似Tab效果)
      function _getBtnCurrentStyle(id) {
        if (id == $scope.curClickedBtnID) {
          return "button blueButton";
        } else {
          return "button";
        }
      }

      //  点击展开事件
      function _toggle(node) {

        //  如果是叶子节点(用户) 或 正在初始化, 则返回
        if (node.type == "user_node" || $scope.inited === false) {
          return;
        }

        //  如果已经有请求过该节点, 则直接展开, 否则请求下一级节点信息
        if (node.status == 'collapsed') {
          node.status = 'expanded';
        } else if (node.status == 'expanded') {
          node.status = 'collapsed';
        } else {
          bindChildren(node);
        }

      }


      function _select(node, $event) {
        if ($scope.lastCheckNode === null) {
          $scope.lastCheckNode = node;
        }

        if (node.checked === true) {
          $scope.lastCheckNode = null;
        } else if ($scope.lastCheckNode !== null) {
          $scope.lastCheckNode.checked = false;
          $scope.lastCheckNode = node;
        }
        node.checked = !node.checked;

        if (typeof($event.stopPropagation) == "function") {
          $event.stopPropagation();
        }
        var param = {
          "name": node.name,
          "id": node.id
        };

        if (isIOS()) {
          closePageIOS("updateOrgParams", JSON.stringify(param));
          return;
        }
        switchToPage("action_finish_orgtree", "/new.html", {
          "name": node.name,
          "id": node.id
        });
      }

      //  切换"已阅用户"界面
      function _read(id) {
        $scope.curClickedBtnID = id;
        if (!$scope.isread) {
          $rootScope.nodeLoaded = false;
          $scope.isread = true;
          collapseAllUserNodes();
        }
      }

      //  切换"未阅用户"界面
      function _unRead(id) {
        $scope.curClickedBtnID = id;
        if ($scope.isread) {
          $rootScope.nodeLoaded = false;
          $scope.isread = false;
          collapseAllUserNodes();
        }
      }

      //  条件判断当前节点是否是叶节点(用户节点)
      function _userNode(node) {
        return node.type == "user_node";
      }

      function nodeInitCallback() {
        //  目前只有一个node_id, 所以只会循环一次, 如果后续有多个node_id, 该逻辑需要修正
        for (var index in $scope.notice_detail.target_nodes) {
          if (+$scope.notice_detail.target_nodes[index] === 0) {
            root = $scope.node = {
              id: 0,
              name: $translate.instant('ROOT_NODE'),
              level: 0
            };
            bindChildren(root);
            break;
          } else {
            if (!g_org_id) {
              return;
            }
            //获取节点信息
            if (v_org_id) {
              //虚拟组织要获取组织信息
              $.getJSON(UC_API_BASE_VIRTUAL + '/virtual_organizations/' + v_org_id + '/organizations/' + g_org_id + '/orgnodes/' + $scope.notice_detail.target_nodes[index], {},
                _getOrgSuccess, _failure);
            } else {
              $.getJSON(UC_API_BASE + '/organizations/' + g_org_id + '/orgnodes/' + $scope.notice_detail.target_nodes[index], {},
                _getOrgSuccess, _failure);
            }
          }
        }
      }

      //  初始化节点
      function _nodeInit() {
        if (g_userInfo.user_id) {
          //  初始化根节点
          var root = {
            id: 0,
            name: $translate.instant('ROOT_NODE'),
            level: 0
          };
          root.nodes = [];
          $scope.node = {};
          $scope.isshowuser = true;

          //  从localstorage中获取该通知公告的详情
          $scope.notice_detail = [];
          var noticeId = $.getUrlParam('noticeId');
          var key = 'notice_detail_' + noticeId;

          if (window.localStorage && localStorage[key]) {
            $scope.notice_detail = JSON.parse(localStorage[key]);
            nodeInitCallback();
          } else {
            dataService.getNoticeDetail(noticeId, function(data) {
              $scope.notice_detail = data;
              nodeInitCallback();
            });
          }
          //nodeInitCallback();
        } else {
          setTimeout(function() {
            _nodeInit();
          }, 200);
        }

      }

      var userNodes = [];

      function collapseAllUserNodes() {
        un = userNodes;
        userNodes = [];
        $.each(un, function(i, node) {
          if (node.level === 0) {
            bindChildren($scope.node);
          } else {
            $scope.safeApply(function() {
              node.status = null;
              node.nodes = [];
              node.userNodes = [];
            });
          }
        });
        $rootScope.nodeLoaded = true;
      }

      $scope.safeApply = function(fn) {
        var phase = this.$root.$$phase;
        if (phase == '$apply' || phase == '$digest') {
          if (fn && (typeof(fn) === 'function')) {
            fn();
          }
        } else {
          this.$apply(fn);
        }
      };
      var _failure = function() {
        utils.log($translate.instant('MESSAGE_GET_NODE_FAILED'));
      };

      var _getOrgSuccess = function(data) {
        var node_id = data.node_id;
        var node_name = data.node_name;
        //$scope.$apply();

        var root = $scope.node = {
          id: node_id,
          name: node_name,
          level: 0
        };
        bindChildren(root);
        //dataService.getNodes(node_id, 0, function (data) {
        //    root.status = 'expanded';
        //    root.nodes = data;
        //    if (data.length === 0) {
        //        utils.performanceLog('#0022', 'start');
        //        dataService.getUser($scope.notice_detail.id, node_id, 0, $scope.isread, function (userData) {
        //            userNodes.push(root);
        //            root.nodes = userData;
        //            $scope.$apply();
        //            utils.performanceLog('#0022', 'end');
        //        });
        //    }
        //});
      };

      function bindChildren(node) {
        dataService.getNodes(node.id, node.level, function(data) {
            node.status = 'expanded';

            //$scope.$apply();  应为调用promise 去掉
            // 有子节点，也可能会有用户
            node.nodes = data;
            if ($scope.isshowuser) {
              userNodes.push(node);
              utils.performanceLog('#0022', 'start');

              dataService.getUser($scope.notice_detail.id, node.id, node.level, $scope.isread, function(userData) {
                $scope.safeApply(function() {
                  node.userNodes = userData;
                  if (!userData.length) {
                    $rootScope.nodeLoaded = true;
                  }
                });

                utils.performanceLog('#0022', 'end');
              });
            } else {
              $rootScope.nodeLoaded = true;
            }
          },
          _failure()
        );
      }

    }
  ])

.run(['$cacheFactory', function($cacheFactory) {
  //增加组织结构缓存
  $cacheFactory('org.node.cache');
  $cacheFactory('org.user.cache');
}])

.service("orgDataService", ['$cacheFactory', '$q', function($cacheFactory, $q) {
  var nodeCache = $cacheFactory.get('org.node.cache');
  var getNodes = function(id, level, callback, error) {
    var cacheKey = 'id' + id + '-level' + level;
    //check 缓存
    if (nodeCache.get(cacheKey)) {
      callback(nodeCache.get(cacheKey));
    } else {
      //用promise替代回调
      var deferred = $q.defer();
      _getNodesFromAPI(id, level, deferred);
      //定义好resolve 和reject
      deferred.promise.then(function(nodes) {
        nodeCache.put(cacheKey, nodes);
        callback(nodes);
      }, function() {
        if (typeof(error) == 'function') {
          error();
        }
      });
    }
  };

  function _getNodesFromAPI(id, level, deferred) {
    if (!g_org_id) {
      return;
    }

    if (v_org_id) {
      $.getJSON(UC_API_BASE_VIRTUAL + '/virtual_organizations/' + v_org_id + '/organizations/' + g_org_id + '/orgnodes/' + id + '/childnodes', {
        'user_id': g_userInfo.user_id,
        '$offset': 0,
        '$limit': 500
      }, function(data) {
        deferred.resolve(
          data.items.map(function(item) {
            return {
              id: item.node_id,
              name: item.node_name,
              level: level + 1
            };
          })
        );
      }, function() {
        deferred.reject();
      });
    } else {
      $.getJSON(UC_API_BASE + '/organizations/' + g_org_id + '/orgnodes/' + id + '/childnodes', {
        '$offset': 0,
        '$limit': 500
      }, function(data) {
        deferred.resolve(
          data.items.map(function(item) {
            return {
              id: item.node_id,
              name: item.node_name,
              level: level + 1
            };
          })
        );
      }, function() {
        deferred.reject();
      });
    }


  }


  //  获取节点下用户信息
  var getUser = function(notice_id, node_id, level, isRead, callback, error) {
    //  未读的情况需要加参数(type=unread)
    var req = {};
    if (isRead === false) {
      req = {
        "type": "unread"
      };
    }
    if (v_org_id) {
      req.orgId = g_org_id;
      req.v_org_id = v_org_id;
    }
    var userCache = $cacheFactory.get('org.user.cache');
    var cacheKey = 'notice' + notice_id + '-node' + node_id + '-isRead' + isRead;
    //check 缓存
    if (userCache.get(cacheKey)) {
      callback(userCache.get(cacheKey));
    } else {
      $.getJSON('/notices/' + notice_id + '/receipts/' + node_id + '/details', req,
        function(data) {
          var nodes = [];
          if (!data.user_ids || !data.user_ids.length) {
            userCache.put(cacheKey, nodes);
            callback(nodes);
            return;
          }

          var ids = data.user_ids.map(function(id) {
            return {
              "user_id": id
            };
          });

          if (v_org_id) {
            $.postJSON(UC_API_BASE_VIRTUAL + '/virtual_organizations/' + v_org_id + '/users/actions/query?realm=' + g_org_id + '.sdp.nd', ids, function(data) {
              data.items.forEach(function(item) {
                item.user_name = item.nick_name || item.org_exinfo.real_name || item.org_exinfo['org.real_name'] || item.user_name || item.user_id || $translate.instant('LEFT_OFFICE');
                // if (!item.user_name) {
                //   item.user_name = item.user_id;
                //   if (item.user_id === "") {
                //     item.user_name = $translate.instant('LEFT_OFFICE');
                //   }
                // }
                var node = {
                  id: item.user_id,
                  name: item.user_name,
                  level: level + 1,
                  type: "user_node"
                };
                nodes.push(node);
              });
              //nodes.sort(function(a, b){return a.name > b.name?1:-1;});
              userCache.put(cacheKey, nodes);
              callback(nodes);
            }, function() {
              error();
            });
          } else {
            $.postJSON(UC_API_BASE + '/users/actions/query?realm=notice-admin.sdp.nd', ids, function(data) {
              data.items.forEach(function(item) {
                item.user_name = item.nick_name || item.org_exinfo.real_name || item.org_exinfo['org.real_name'] || item.user_name || item.user_id || $translate.instant('LEFT_OFFICE');
                // item.user_name = item.nick_name;
                // if (!item.user_name) {
                //   item.user_name = item.user_id;
                //   if (item.user_id === "") {
                //     item.user_name = $translate.instant('LEFT_OFFICE');
                //   }
                // }
                var node = {
                  id: item.user_id,
                  name: item.user_name,
                  level: level + 1,
                  type: "user_node"
                };
                nodes.push(node);
              });
              //nodes.sort(function(a, b){return a.name > b.name?1:-1;});
              userCache.put(cacheKey, nodes);
              callback(nodes);
            }, function() {
              error();
            });
          }

        },
        function() {
          error();
        });
    }


  };

  //获取详细页
  var getNoticeDetail = function(send_notice_id, callback) {
    if (send_notice_id) {
      var req = {};
      if (v_org_id) {
        req.orgId = g_org_id;
        req.v_org_id = v_org_id;
      }
      $.getJSON('/notices/' + send_notice_id, req)
        .done(function(data) {
          callback(data);
        })
        .fail(function(data) {});
    }
  };


  return {
    getNodes: getNodes,
    getUser: getUser,
    getNoticeDetail: getNoticeDetail
  };

}]).directive('ngStaticInclude', [
  '$compile',
  '$templateCache',
  function($compile, $templateCache) {
    return {
      restrict: 'A',
      priority: 400,
      compile: function(element, attrs) {
        var templateName = attrs.ngStaticInclude;
        var template = $templateCache.get(templateName);
        element.html(template);
        //return function(scope, element){
        //    element.html(template);
        //    $compile(element.contents())(scope);
        //};
      }
    };
  }
]);
