/**
 * Created by Shejn on 2015/4/9.
 */

var receive_notice_id = null;
var vorgId, orgId;

function get_receive_info() {
  if (window.localStorage) {
    receive_notice_id = $.getUrlParam('noticeId') || localStorage.receive_notice_id;
  }
}

//设置已读、未读
function setReadUpandDown(noticeId) {
  if (window.localStorage) {
    var readInfo = {};
    var userId = g_userInfo.user_id || $.getUrlParam('uid');

    if (localStorage.read_info) {
      readInfo = JSON.parse(localStorage.read_info);
    }

    if (!readInfo[userId]) readInfo[userId] = {};
    else if (readInfo[userId][noticeId]) return;
    (readInfo[userId][noticeId] = true);
    localStorage.read_info = JSON.stringify(readInfo);
    callCordova(function() {
      cordova.plugins.CommonServiceApi.actionRefresh();
    });
  }
}

function getReceiveDetail(callback) {
  if (receive_notice_id !== undefined) {
    var req = {};
    var url = '/received_notices/' + receive_notice_id;
    if (vorgId) {
      req.orgId = orgId;
      req.v_org_id = vorgId;
    }
    $.getJSON(url, req)
    .done(function(data) {
      setReadUpandDown(receive_notice_id);
      callback(data);
    })
    .fail(function(data) {});
  }
}

angular.module('notice.received.detail', ['service.util', 'widget.async.img', 'widget.async.img.fit', 'service.language'])
  .constant('receivedetailCtrl.config', {
    //缩略文字的最大长度配置
    'maxLength': 5
  })
  .controller('receivedetailCtrl', ['$scope', 'utilService', '$timeout', '$location', '$sce', 'receivedetailCtrl.config', '$translate',
    function($scope, utils, $timeout, $location, $sce, config, $translate) {

      $scope.inited = false;
      $scope.items = [];
      $scope.receiveDetailStatus = $translate.instant('MESSAGE_PLEASE_CHECK_NETWORK');
      $scope.mScrollerHeight = document.documentElement.clientHeight - (mMobileDevice ? 10 : 50) - 45;

      $scope.lastReceiveNoticeId = "";
      $scope.lastReceiveNoticeTitle = $translate.instant('NO_MORE');
      $scope.nextReceiveNoticeId = "";
      $scope.nextReceiveNoticeTitle = $translate.instant('NO_MORE');

      $scope.init = function() {
        get_receive_info();

        if (receive_notice_id === undefined) {
          NativeToast($translate.instant('MESSAGE_NOTICE_NOT_EXIST'));
        }

        $scope.initReceiveDetail();
      };

      $scope.isOffLine = function() {
        if ($scope.inited) {
          return $scope.isNoContent;
        }

        return false;
      };

      $scope.isLoadingDetail = function() {
        return !$scope.inited;
      };

      $scope.imgClick = function(index) {
        var imgs = [];
        for (var img in $scope.notice.images) {
          imgs.push(utils.convert_url($scope.notice.images[img], 960));
        }
        utils.viewPic(imgs, index);
      };

      function _getReceiveDetail() {
        if (g_userInfo.user_id) {
          vorgId = g_userInfo.org_exinfo.v_org_id;
          orgId = g_userInfo.org_id;
          getReceiveDetail(function(data) {
            var receive_detail = data;
            var image_type = 0;
            var thumbSize = 160;
            var receive_imgs = [];
            if (null !== receive_detail) {

              $scope.publish_time = receive_detail.publish_time;

              //  去重
              receive_detail.images = utils.uniqueArray(receive_detail.images);

              if (receive_detail.images.length == 1) {
                //thumbSize = 240;
                image_type = 1;
              } else if (receive_detail.images.length <= 4) {
                //thumbSize = 120;
                image_type = 2;
              }

              for (var img in receive_detail.images) {
                receive_imgs.push(utils.convert_url(receive_detail.images[img], thumbSize));
              }
            } else {
              return;
            }

            var size = 99;
            switch (image_type) {
              case 0:
                size = 99;
                break;
              case 1:
                size = 299;
                $scope.isSingleImg = true;
                break;
              case 2:
                size = 149;
                break;
            }

            $scope.receiveDetailTitle = receive_detail.title;
            $scope.receiveDetailContent = $sce.trustAsHtml(utils.editorImgParse(receive_detail.content));
            $scope.receiveDetailPublisher = receive_detail.publisher;
            $scope.receiveDetailPublishTime = utils.formatDateTime(receive_detail.publish_time, 1);

            $scope.images = receive_imgs;
            $scope.inited = true;
            $scope.imgSize = size;
            $scope.isNoContent = false;
            $scope.notice = receive_detail;
            utils.performanceLog('#0011,#0014,#0015,#0016,#0017,#0018', 'end');

            $scope.getNearbyNoticeTitle($scope.notice.publish_time, 1);
          });
        } else {
          setTimeout(function() {
            _getReceiveDetail();
          }, 200);
        }
      }

      $scope.initReceiveDetail = function() {
        utils.performanceLog('#0011', 'start');

        $scope.inited = false;
        $scope.isNoContent = true;
        $scope.isSingleImg = false;
        _getReceiveDetail();
      };

      $scope.lastReceiveNotice = function() {
        if ($scope.lastReceiveNoticeId) {
          receive_notice_id = $scope.lastReceiveNoticeId;
          $scope.initReceiveDetail();

          utils.performanceLog('#0014', 'start');
        }
      };

      $scope.nextReceiveNotice = function() {
        if ($scope.nextReceiveNoticeId) {
          receive_notice_id = $scope.nextReceiveNoticeId;
          $scope.initReceiveDetail();

          utils.performanceLog('#0014', 'start');
        }
      };

      $scope.getLastReceiveNoticeTitle = function() {
        if ($scope.lastReceiveNoticeId === "") {
          return $scope.lastReceiveNoticeTitle;
        }

        return $scope.lastReceiveNoticeTitle.shorten(config.maxLength);
      };

      $scope.getNextReceiveNoticeTitle = function() {
        if ($scope.nextReceiveNoticeId === "") {
          return $scope.nextReceiveNoticeTitle;
        }

        return $scope.nextReceiveNoticeTitle.shorten(config.maxLength);
      };

      /**
       * 获取 上一条新闻的标题色值
       * @returns {*}
       */
      $scope.getLastNewsTitleColor = function() {
        if ($scope.lastReceiveNoticeId !== "") {
          return '#3172ee';
        } else {
          return '#808080';
        }
      };

      /**
       * 获取 下一条新闻的标题色值
       * @returns {*}
       */
      $scope.getNextNewsTitleColor = function() {
        if ($scope.nextReceiveNoticeId !== "") {
          return '#3172ee';
        } else {
          return '#808080';
        }
      };

      //  获取已接收的公告列表
      $scope.getNearbyNoticeTitle = function(publishTime, size) {
        var req = {
          "ptime": publishTime,
          "size": size
        };
        var url = '/received_notices/nearby';
        if (vorgId) {
          req.orgId = orgId;
          req.v_org_id = vorgId;
        }
        $.getJSON(url, req).
        done(function(data) {
          if (data.after.length) {
            $scope.lastReceiveNoticeId = data.after[0].id;
            $scope.lastReceiveNoticeTitle = data.after[0].title;
          } else {
            $scope.lastReceiveNoticeId = "";
            $scope.lastReceiveNoticeTitle = $translate.instant('NO_MORE');
          }

          if (data.before.length) {
            $scope.nextReceiveNoticeId = data.before[0].id;
            $scope.nextReceiveNoticeTitle = data.before[0].title;
          } else {
            $scope.nextReceiveNoticeId = "";
            $scope.nextReceiveNoticeTitle = $translate.instant('NO_MORE');
          }

          $scope.$digest();
        }).
        fail(function(data) {
          console.log(data);
          $scope.$digest();
        });
      };

    }
  ]);
