/**
 * Created by Shejn on 2015/4/2.
 */

angular.module('notice.receives', ['service.util', 'service.language'])
  .controller('receiveCtrl', ['$scope', 'utilService', '$translate', function($scope, utils, $translate) {
    var cachePrefix = 'cache_receive_notice_';
    var cacheKey = cachePrefix + $.getUrlParam('uid');

    $scope.maxts = 0;
    $scope.mints = 0;
    $scope.inited = false;
    $scope.cache = false;
    $scope.offline = false;
    $scope.historyRequest = false;
    $scope.items = [];
    $scope.bHttpRequest = false;
    $scope.noMoreItemsAvailable = false;
    $scope.receiveListStatus = $translate.instant('MESSAGE_NOTICE_NOT_RECEIVED');
    $scope.readInfo = {};
    $scope.getRead = function(noticeId) {
      var userId = g_userInfo.user_id || $.getUrlParam('uid');
      if (window.localStorage) {
        if (localStorage.read_info) {
          var readInfo = JSON.parse(localStorage.read_info);
          if (readInfo[userId]) {
            $scope.readInfo = readInfo[userId];
            if ($scope.readInfo[noticeId]) return true;
          }
        }
      }
      return false;
    };

    $scope.data = {
      showDelete: false
    };



    function checkPermission() {

      ajax_check_permission(function(response) {
        if (response.has_permission) {
          var sendHistoryTitle = $translate.instant('NOTICE_SEND_HISTORY_TITLE');
          var newTitle = $translate.instant('NOTICE_NEW_TITLE');
          var selectVOrg = $translate.instant('NOTICE_SELECT_VORG');
          var cancelLabel = $translate.instant('CANCEL');
          callCordova(function() {
            var params;
            if (isIOS()) {
              params = [{
                "menu": newTitle,
                "params": "post_notice",
                "url": ASSETS_BASE + "/new.html",
                "addRefresh": false
              }, {
                "menu": sendHistoryTitle,
                "params": "sended_list",
                "url": ASSETS_BASE + "/sendList.html",
                "addRefresh": true
              }, {
                "menu": cancelLabel,
                "params": "cancel",
                "url": "",
                "addRefresh": false
              }];
              cordova.plugins.FPlugin.initMenuViewEx(null, null, params);
            } else if (isAndroid()) {
              params = [{
                "menu": newTitle,
                "params": "post_notice",
                "url": ASSETS_BASE + "/new.html"
              }, {
                "menu": sendHistoryTitle,
                "params": "sended_list",
                "url": ASSETS_BASE + "/sendList.html"
              }];
              cordova.plugins.CommonServiceApi.pageMenu(params);
            }
          });
        }
      }, function() {
        console.log("get permission error");
      }).always(
        function() {

          var a = 'getUserSuccessForPermission';
          var b = 'getUserFailForPermission';
          window[a] = function(response) {
            setStorage('user_info', response);
            (function() {
              ajax_cs_path();
            })();
          };

          window[b] = function() {
            noticeLog("get user info error");
            (function() {
              ajax_cs_path();
            })();
          };
          if (mPlatformAndroid) {
            JsHttpRequest.getCurrentUser(a, b);
          } else if (mPlatformIOS) {
            MUICordovaWebJSExport.getUserInfo(a, b);
          }
        }
        /*function () {
          ajax_get_current_user(function (response) {
            setStorage('user_info', response);

          }, function (response, code) {
            noticeLog("get user info error");
          }).always(
            function () {
              ajax_cs_path();
            }
          );
        }*/
      );
    }

    function _init() {
      if (g_userInfo.user_id) {
        $scope.orgId = g_userInfo.org_id;
        $scope.vorgId = g_userInfo.org_exinfo.v_org_id;
        $scope.getRecentReceiveNotices(0, 15);

        callCordova(function() {
          if (isIOS()) {
            cordova.plugins.FPlugin.addPullRefresh();
          }
        });

        checkPermission();
      } else {
        setTimeout(function(){
          _init();
        }, 200);
      }
    }

    $scope.init = function() {
      _init();
    };

    window.onWebviewWillUpdate = function() {
      //刷新已读/未读状态
      $scope.$apply();
    };

    $scope.onItemDetails = function(index) {

      if (window.localStorage) {
        //localStorage.receive_item_index = index;
        //localStorage.receive_items = JSON.stringify($scope.items);
        localStorage.receive_notice_id = $scope.items[index].id;
      }

      var url = "/receiveDetail.html" + ($scope.items[index].id !== undefined ? "?noticeId=" + $scope.items[index].id : "");
      if (isIOS()) {
        switchToPageIOS(url);
        return;
      }
      switchToPage('action_notice_detail', url);
    };


    //  判断当前列表是否为空
    $scope.isItemsEmpty = function() {

      if ($scope.inited) {
        return ($scope.items.length <= 0);
      }

      return false;
    };


    function handler() {
      var items;
      if (window.localStorage) {
        if (mPlatformIOS) {
          items = localStorage.getItem(cacheKey);
        }
        if (mPlatformAndroid) {
          items = JsSaveSp.getItem(cacheKey);
        }


        if (items) {
          items = (JSON.parse(items));
          items.forEach(function(item) {
            Object.keys(item).forEach(function(key) {
              if (key === '$$hashKey') {
                delete item.$$hashKey;
              }
            });
          });


          $scope.items = items;

        }
      }


      if ($scope.items.length === 0) {
        $scope.receiveListStatus = $translate.instant('MESSAGE_NOTICE_NOT_RECEIVED');
      } else {

        $scope.maxts = $scope.items[0].publish_time;

        //  记录上拉获取历史记录的时间戳, 只有在第一次调用getRecentReceiveNotices时赋值, 此外都在getHistoryReceiveNotices时赋值;
        $scope.mints = $scope.items[$scope.items.length - 1].publish_time;

      }

      $scope.bHttpRequest = false;
      $scope.inited = true;
      $scope.cache = true;
    }

    //  获取新的公告列表
    $scope.getRecentReceiveNotices = function(maxts, size) {
      utils.performanceLog('#0001,#0004,#enter', 'start1');
      var req = {
        "maxts": maxts,
        "size": size
      };
      if ($scope.orgId) {
        req.orgId = $scope.orgId;
      }
      if ($scope.vorgId) {
        req.v_org_id = $scope.vorgId;
      }
      if (!$scope.inited) {

        handler();
      }
      if (!$scope.bHttpRequest) {
        $scope.bHttpRequest = true;
        $.getJSON('/received_notices', req).
        done(function(response) {

          if ($scope.offline) {
            checkPermission();
          }

          if (response.items.length > 0) {
            $scope.maxts = response.items[0].publish_time;
            if (!$scope.inited || ($scope.inited && $scope.cache && !$scope.mints)) {
              //  记录上拉获取历史记录的时间戳, 只有在第一次调用getRecentReceiveNotices时赋值, 此外都在getHistoryReceiveNotices时赋值;
              $scope.mints = response.items[response.items.length - 1].publish_time;
            }

            response.items.reverse();


            if ($scope.inited && $scope.cache && !$scope.offline && !$scope.historyRequest) {
              //第一次要清空$scope.items
              $scope.items = [];
            }


            response.items.forEach(function(item) {
              $scope.items.unshift(item);
            });
            try {
              if (window.localStorage) {
                //移除旧的，更新最新的缓存

                if (mPlatformIOS) {
                  localStorage.removeItem(cacheKey);
                  localStorage.setItem(cacheKey, JSON.stringify($scope.items.slice(0, 15)));
                }
                if (mPlatformAndroid) {
                  JsSaveSp.removeItem(cacheKey);
                  JsSaveSp.setItem(cacheKey, JSON.stringify($scope.items.slice(0, 15)));
                }
              }
            } catch (e) {
              Object.keys(window.localStorage).forEach(function(key) {
                if (key.indexOf(cachePrefix) !== -1) {
                  if (mPlatformIOS) {
                    localStorage.removeItem(key);
                  }
                  if (mPlatformAndroid) {
                    JsSaveSp.removeItem(key);
                  }
                }
              });

            }

          }

          if (response.items.length > 0) {
            if ($scope.inited === true) {
              NativeToast($translate.instant('MESSAGE_NOTICE_NEW_LOADED', {
                number: response.items.length
              }));
            }
          } else if ($scope.items.length === 0) {
            NativeToast($translate.instant('MESSAGE_NOTICE_NOT_RECEIVED'));
          } else {
            NativeToast($translate.instant('MESSAGE_NOT_MORE_NOTICE'));
          }

          if ($scope.items.length === 0) {
            $scope.receiveListStatus = $translate.instant('MESSAGE_NOTICE_NOT_RECEIVED');
          }

          $scope.bHttpRequest = false;
          $scope.inited = true;
          $scope.cache = false;
          $scope.offline = false;
          $scope.$digest();
          $scope._donePullDown();
          utils.performanceLog('#0001,#0004,#success', 'end');
        }).
        fail(function(response) {
          if (/NOTICES\/ORGANIZATION_NOT_EXIST/.test(response.code)) {
            $scope.receiveListStatus = $translate.instant('NOTICES/ORGANIZATION_NOT_EXIST');
            $scope.bHttpRequest = false;
            $scope.inited = true;
            $scope.cache = false;
            $scope.offline = false;
            $scope.$digest();
            $scope._donePullDown();
          } else {
            $scope.receiveListStatus = $translate.instant('MESSAGE_PLEASE_CHECK_NETWORK');
            $scope.offline = true;
            $scope.bHttpRequest = false;
            $scope.inited = true;
            $scope._donePullDown();
          }
          utils.performanceLog('#0001,#0004,#fail', 'end');
        });
      }
    };

    $scope.getHistoryReceiveNotices = function(mints, size) {
      utils.performanceLog('#0005', 'start');

      var req = {
        "mints": mints,
        "size": size
      };
      if ($scope.orgId) {
        req.orgId = $scope.orgId;
      }
      if ($scope.vorgId) {
        req.v_org_id = $scope.vorgId;
      }

      if (!$scope.noMoreItemsAvailable && !$scope.bHttpRequest) {
        $scope.bHttpRequest = true;
        $.getJSON('/received_notices', req).
        done(function(response) {
          if ($scope.offline) {
            checkPermission();
          }

          if (response.items.length > 0) {
            $scope.mints = response.items[response.items.length - 1].publish_time;

            response.items.forEach(function(item) {
              $scope.items.push(item);
            });
          }

          //  "<15" 包含"<0"和"<15" 说明已无历史公告可取, 无需上拉刷新
          if (response.items.length < 15) {
            $scope.noMoreItemsAvailable = true;
          }

          if ($scope.items.length === 0) {
            $scope.receiveListStatus = $translate.instant('MESSAGE_NOTICE_NOT_RECEIVED');
          }

          $scope.bHttpRequest = false;
          $scope.offline = false;
          $scope.historyRequest = true;
          $scope._donePullUp(response.items.length);
          $scope.$digest();

          utils.performanceLog('#0005', 'end');

          if (response.items.length > 0) {
            NativeToast($translate.instant('MESSAGE_NOTICE_NEW_LOADED', {
              number: response.items.length
            }));
          } else {
            NativeToast($translate.instant('MESSAGE_NOT_MORE_NOTICE'));
          }
        }).
        fail(function(response) {
          console.log(response);
          $scope.receiveListStatus = $translate.instant('MESSAGE_PLEASE_CHECK_NETWORK');
          $scope.bHttpRequest = false;
          $scope.offline = true;
          $scope._donePullUp(0);
          utils.performanceLog('#0005', 'end');
        });
      } else if ($scope.noMoreItemsAvailable) {
        NativeToast($translate.instant('MESSAGE_NOT_MORE_NOTICE'));
        $scope._donePullUp(0);
      }
    };

    $scope._donePullDown = function() {
      if (cordova) {
        if (isAndroid()) {
          cordova.plugins.CommonServiceApi.donePulldown();
        } else if (isIOS()) {
          cordova.plugins.FPlugin.actionDonePullDown(null, null);
        }
      }
    };

    $scope._donePullUp = function(size) {
      if (cordova) {
        if (isAndroid()) {
          cordova.plugins.CommonServiceApi.donePullup(size);
        } else if (isIOS()) {
          cordova.plugins.FPlugin.actionDonePullUp(null, null);
        }
      }
    };


    /*****************************************************************/
    window.startPullDownToRefresh = function() {
      var time = $translate.instant('UPDATE_TIME') + utils.formatDateTime($scope.maxts === 0 ? new Date().getTime() : $scope.maxts, 1);
      if (mPlatformAndroid) {
        webView.setRefreshTime(time);
      } else if (mPlatformIOS) {
        cordova.plugins.FPlugin.sendCmd(null, null, 'action_setRefreshTime', time);
      }

    };

    window.onPullDownToRefresh = function() {
      $scope.getRecentReceiveNotices($scope.maxts, 15);
    };
    window.afterVOrgToRefresh = function(vorgId, orgId) {
      setStorage('targetOrgId', orgId);
      setStorage('vorgId', vorgId);
      $scope.items = [];
      $scope.orgId = orgId;
      $scope.vorgId = vorgId;
      $scope.getRecentReceiveNotices(0, 15);
    };
    window.onPullUpToRefresh = function() {
      $scope.getHistoryReceiveNotices($scope.mints, 15);
    };

  }]);
