/**
 * Created by Shejn on 2015/4/7.
 */
angular.module('notice.detail', ['service.util', 'widget.async.img', 'widget.async.img.fit', 'service.language'])
  .constant('detailCtrl.config', {
    //缩略文字的最大长度配置
    'maxLength': 5
  })
  .controller('detailCtrl', ['$scope', "utilService", '$timeout', '$location', 'detailCtrlService', '$sce', 'detailCtrl.config', '$translate',
    function($scope, utils, $timeout, $location, detailCtrlService, $sce, config, $translate) {

      var send_notice_id = null;

      $scope.lastSendNoticeId = "";
      $scope.lastSendNoticeTitle = $translate.instant('NO_MORE');
      $scope.nextSendNoticeId = "";
      $scope.nextSendNoticeTitle = $translate.instant('NO_MORE');

      $scope.init = _init;

      function _init() {
        if(g_userInfo.user_id){
          $scope.inited = false;
          $scope.mScrollerHeight = document.documentElement.clientHeight - (mMobileDevice ? 10 : 50) - 45;
          $scope.sendDetailStatus = $translate.instant('MESSAGE_PLEASE_CHECK_NETWORK');
          _get_notice_info();
          _bindFunctions();
          _initNoticeDetail();
        } else {
          setTimeout(function(){
            _init();
          }, 200);
        }
      }

      function _bindFunctions() {
        $scope.imgClick = _imgClick;
        $scope.noticeFeedBack = _noticeFeedBack;
        $scope.lastSendNotice = _lastSendNotice;
        $scope.nextSendNotice = _nextSendNotice;
        $scope.getLastSendNoticeTitle = _getLastSendNoticeTitle;
        $scope.getNextSendNoticeTitle = _getNextSendNoticeTitle;
        $scope.getLastNewsTitleColor = _getLastNewsTitleColor;
        $scope.getNextNewsTitleColor = _getNextNewsTitleColor;
        $scope.isLoadingDetail = _isLoadingDetail;
        $scope.isOffLine = _isOffLine;
      }

      function _isOffLine() {
        if ($scope.inited) {
          return $scope.isNoContent;
        }
        return false;
      }

      function _isLoadingDetail() {
        return !$scope.inited;
      }

      function _get_notice_info() {
        if (window.localStorage) {
          send_notice_id = $.getUrlParam('noticeId') || localStorage.send_notice_id;
        }
      }

      function _imgClick(index) {
        var imageArray = [];
        $scope.notice.images.forEach(function(img) {
          imageArray.push(utils.convert_url(img, 960));
        });
        utils.viewPic(imageArray, index);
      }

      function _initNoticeDetail() {
        utils.performanceLog('#0011', 'start');

        $scope.inited = false;
        //$scope.isNoContent = true;
        $scope.isSingleImg = false;
        detailCtrlService._getNoticeDetail(send_notice_id, function(data) {
          var notice_detail = data;
          $scope.isNoContent = false;

          if (!notice_detail) {
            NativeToast($translate.instant('MESSAGE_PLEASE_CHECK_NETWORK'));
            return;
          }

          var image_type = 0;
          var thumbSize = 160;
          var notice_imgs = [];
          //  去重
          notice_detail.images = utils.uniqueArray(notice_detail.images);

          if (notice_detail.images.length === 1) {
            //thumbSize = 240;
            image_type = 1;
          } else if (notice_detail.images.length <= 4) {
            //thumbSize = 120;
            image_type = 2;
          }

          notice_detail.images.forEach(function(img) {
            notice_imgs.push(utils.convert_url(img, thumbSize));
          });

          var size = 99;
          switch (image_type) {
            case 0:
              size = 99;
              break;
            case 1:
              size = 299;
              $scope.isSingleImg = true;
              break;
            case 2:
              size = 149;
              break;
          }

          //  页面大小还原并置顶
          $timeout(function() {
            $(window).scrollTop(0);
          }, 0);

          //  应用数据
          $scope.noticeDetailTitle = notice_detail.title;
          $scope.noticeDetailContent = $sce.trustAsHtml(utils.editorImgParse(notice_detail.content));
          $scope.noticeDetailPublisher = notice_detail.publisher;
          $scope.noticeDetailPublishTime = utils.formatDateTime(notice_detail.publish_time, 1);

          $scope.inited = true;
          $scope.imgSize = size;
          $scope.images = notice_imgs;
          $scope.notice = notice_detail;
          utils.performanceLog('#0011,#0014,#0015,#0016,#0017,#0018', 'end');

          detailCtrlService._getNearByNoticeTitle($scope.notice.publish_time, 1, function(data) {
            if (data.after.length) {
              $scope.lastSendNoticeId = data.after[0].id;
              $scope.lastSendNoticeTitle = data.after[0].title;
            } else {
              $scope.lastSendNoticeId = "";
              $scope.lastSendNoticeTitle = $translate.instant('NO_MORE');
            }

            if (data.before.length) {
              $scope.nextSendNoticeId = data.before[0].id;
              $scope.nextSendNoticeTitle = data.before[0].title;
            } else {
              $scope.nextSendNoticeId = "";
              $scope.nextSendNoticeTitle = $translate.instant('NO_MORE');
            }

            $scope.$digest();
          });
        });
      }

      function _noticeFeedBack() {
        if (window.localStorage) {
          localStorage['notice_detail_' + $scope.notice.id] = JSON.stringify($scope.notice);
        }

        if (isIOS()) {
          switchToPageIOS("/noticeFeedback.html?noticeId=" + $scope.notice.id);
          return;
        }
        switchToPage('action_notice_feedback', '/noticeFeedback.html?noticeId=' + $scope.notice.id);
      }

      function _lastSendNotice() {
        if ($scope.lastSendNoticeId) {
          send_notice_id = $scope.lastSendNoticeId;

          _initNoticeDetail();
          utils.performanceLog('#0014', 'start');
        }
      }

      function _nextSendNotice() {
        if ($scope.nextSendNoticeId) {
          send_notice_id = $scope.nextSendNoticeId;

          _initNoticeDetail();
          utils.performanceLog('#0014', 'start');
        }
      }

      function _getLastSendNoticeTitle() {
        if ($scope.lastSendNoticeId === "") {
          return $scope.lastSendNoticeTitle;
        }

        return $scope.lastSendNoticeTitle.shorten(config.maxLength);
      }

      function _getNextSendNoticeTitle() {
        if ($scope.nextSendNoticeId === "") {
          return $scope.nextSendNoticeTitle;
        }

        return $scope.nextSendNoticeTitle.shorten(config.maxLength);
      }

      /**
       * 获取 上一条新闻的标题色值
       * @returns {*}
       */
      function _getLastNewsTitleColor() {
        if ($scope.lastSendNoticeId !== "") {
          return '#3172ee';
        } else {
          return '#808080';
        }
      }

      /**
       * 获取 下一条新闻的标题色值
       * @returns {*}
       */
      function _getNextNewsTitleColor() {
        if ($scope.nextSendNoticeId !== "") {
          return '#3172ee';
        } else {
          return '#808080';
        }
      }

    }
  ])


.service('detailCtrlService', function() {
  this._getNoticeDetail = function(send_notice_id, callback) {
    if (send_notice_id !== null) {
      var req = {};
      var orgId = g_userInfo.org_id;
      var vorgId = g_userInfo.org_exinfo.v_org_id;
      if (vorgId) {
        req.v_org_id = vorgId;
        req.orgId = orgId;
      }
      $.getJSON('/notices/' + send_notice_id, req).
      done(function(data) {
        callback(data);
      }).
      fail(function(data) {});
    }
  };

  this._getNearByNoticeTitle = function(publishTime, size, callback) {
    var req = {
      "ptime": publishTime,
      "size": size
    };
    var orgId = g_userInfo.org_id;
    var vorgId = g_userInfo.org_exinfo.v_org_id;
    if (vorgId) {
      req.v_org_id = vorgId;
      req.orgId = orgId;
    }
    $.getJSON('/notices/nearby', req).
    done(function(data) {
      callback(data);
    }).
    fail(function(data) {
      console.log(data);
      $scope.$digest();
    });
  };
});
