/**
 * Created by Shejn on 2015/4/2.
 */
angular.module('notice.send', ['service.util', 'service.language'])
  .controller('sendCtrl', ['$scope', 'utilService', '$translate', function($scope, utils, $translate) {
    $scope.maxts = 0;
    $scope.mints = 0;
    $scope.inited = false;
    $scope.items = [];
    $scope.bHttpRequest = false;
    $scope.noMoreItemsAvailable = false;
    $scope.sendListStatus = $translate.instant('MESSAGE_PLEASE_CHECK_NETWORK');

    $scope.data = {
      showDelete: false
    };

    function _init() {
      if(g_userInfo.user_id){
        $scope.getRecentSendNotices(0, 15);
      } else {
        setTimeout(function(){
          _init();
        }, 200);
      }
    }

    //  页面初始化, 获取最近的15条信息
    $scope.init = function() {
      _init();
    };

    //  edit按钮事件
    $scope.edit = function(item) {
      alert('Edit Item: ' + item.id);
    };

    //  判断当前列表是否为空
    $scope.isItemsEmpty = function() {
      if ($scope.inited) {
        return ($scope.items.length <= 0);
      }

      return false;
    };

    //  删除Item项
    $scope.onItemDelete = function(item) {
      $scope.items.splice($scope.items.indexOf(item), 1);
    };

    $scope.onItemDetails = function(index) {
      if (window.localStorage) {
        //localStorage.send_item_index = index;
        //localStorage.send_items = JSON.stringify($scope.items);
        localStorage.send_notice_id = $scope.items[index].id;
      }
      var url = "/sendDetail.html" + ($scope.items[index].id !== undefined ? "?noticeId=" + $scope.items[index].id : "");
      if (isIOS()) {
        switchToPageIOS(url);
        return;
      }
      switchToPage('action_notice_detail', url);
    };

    //  下拉刷新, 查询新的通知公告
    $scope.getRecentSendNotices = function(maxts, size) {
      utils.performanceLog('#0006,#0009', 'start');

      $scope.maxts = maxts;
      $scope.size = size;

      var req = {
        "maxts": $scope.maxts,
        "size": $scope.size
      };
      var vorgId = g_userInfo.org_exinfo.v_org_id;
      var orgId = g_userInfo.org_id;
      var url = '/notices';
      if (!$scope.bHttpRequest) {
        $scope.bHttpRequest = true;
        if (vorgId) {
          req.orgId = orgId;
          req.v_org_id = vorgId;
        }
        $.getJSON(url, req)
          .done(function(response) {
            if (response.items.length > 0) {
              $scope.maxts = response.items[0].publish_time;
              if (!$scope.inited) {
                //  记录上拉获取历史记录的时间戳, 只有在第一次调用getRecentSendNotices时赋值, 此外都在getHistorySendNotices时赋值;
                $scope.mints = response.items[response.items.length - 1].publish_time;
              }

              response.items.reverse();
              response.items.forEach(function(item) {
                $scope.items.unshift(item);
              });
            }

            if (response.items.length > 0) {
              if ($scope.inited === true) {
                NativeToast($translate.instant('MESSAGE_NOTICE_NEW_ADDED', {
                  number: response.items.length
                }));
              }
            } else if ($scope.items.length === 0) {
              NativeToast($translate.instant('MESSAGE_NOTICE_NOT_SENT'));
            } else {
              NativeToast($translate.instant('MESSAGE_NOT_MORE_NOTICE'));
            }



            if ($scope.items.length === 0) {
              $scope.sendListStatus = $translate.instant('MESSAGE_NOTICE_NOT_SENT');
            }

            $scope.bHttpRequest = false;
            $scope.inited = true;
            $scope.$digest();
            $scope._donePullDown();
            utils.performanceLog('#0006,#0009', 'end');
          })
          .fail(function(response) {
            $scope.sendListStatus = $translate.instant('MESSAGE_PLEASE_CHECK_NETWORK');
            console.log(response);
            $scope.bHttpRequest = false;
            $scope.inited = true;
            $scope._donePullDown();
            utils.performanceLog('#0006,#0009', 'end');
          });
      }
    };

    $scope.getHistorySendNotices = function(mints, size) {
      utils.performanceLog('#0010', 'start');

      var req = {
        "mints": mints,
        "size": size
      };

      var vorgId = g_userInfo.org_exinfo.v_org_id;
      var orgId = g_userInfo.org_id;
      if (vorgId) {
        req.orgId = orgId;
        req.v_org_id = vorgId;
      }

      if (!$scope.noMoreItemsAvailable && !$scope.bHttpRequest) {
        $scope.bHttpRequest = true;
        $.getJSON('/notices', req).
        done(function(response) {
          if (response.items.length > 0) {
            $scope.mints = response.items[response.items.length - 1].publish_time;

            response.items.forEach(function(item) {
              //item.displayTitle  = item.title.shorten(config.maxLength);

              $scope.items.push(item);
            });
          }

          //  "<15" 包含"<0"和"<15" 说明已无历史公告可取, 无需上拉刷新
          if (response.items.length < 15) {
            $scope.noMoreItemsAvailable = true;
          }

          if ($scope.items.length === 0) {
            $scope.sendListStatus = $translate.instant('MESSAGE_NOTICE_NOT_SENT');
          }

          $scope.bHttpRequest = false;
          $scope._donePullUp(response.items.length);
          $scope.$digest();

          utils.performanceLog('#0010', 'end');

          if (response.items.length > 0) {
            NativeToast($translate.instant('MESSAGE_NOTICE_NEW_LOADED', {
              number: response.items.length
            }));
          } else {
            NativeToast($translate.instant('MESSAGE_NOT_MORE_NOTICE'));
          }

        }).
        fail(function(response) {
          $scope.sendListStatus = $translate.instant('MESSAGE_PLEASE_CHECK_NETWORK');
          console.log(response);
          $scope.bHttpRequest = false;
          $scope._donePullUp(0);

          utils.performanceLog('#0010', 'end');
        });
      } else if ($scope.noMoreItemsAvailable) {
        NativeToast($translate.instant('MESSAGE_NOT_MORE_NOTICE'));
        $scope._donePullUp(0);
      }

    };

    $scope._donePullDown = function() {
      if (cordova) {
        if (isAndroid()) {
          cordova.plugins.CommonServiceApi.donePulldown();
        } else if (isIOS()) {
          cordova.plugins.FPlugin.actionDonePullDown(null, null);
        }
      }
    };

    $scope._donePullUp = function(size) {
      if (cordova) {
        if (isAndroid()) {
          cordova.plugins.CommonServiceApi.donePullup(size);
        } else if (isIOS()) {
          cordova.plugins.FPlugin.actionDonePullUp(null, null);
        }
      }
    };

    /*****************************************************************/

    window.startPullDownToRefresh = function() {
      var time = $translate.instant('UPDATE_TIME') + utils.formatDateTime($scope.maxts === 0 ? new Date().getTime() : $scope.maxts, 1);

      if (mPlatformAndroid) {
        webView.setRefreshTime(time);
      } else if (mPlatformIOS) {
        cordova.plugins.FPlugin.sendCmd(null, null, 'action_setRefreshTime', time);
      }

    };

    window.onPullDownToRefresh = function() {
      $scope.getRecentSendNotices($scope.maxts, 15);
    };

    window.onPullUpToRefresh = function() {
      $scope.getHistorySendNotices($scope.mints, 15);
    };

  }]);
